cat *.f
( circuit drawing, converted from circuit.c )
( cht 8/22/93 )

DECIMAL
INCLUDE win.f

DECIMAL

VARIABLE xorg
VARIABLE yorg
VARIABLE drawtype
VARIABLE dev
VARIABLE val
VARIABLE x1
VARIABLE y1
VARIABLE x2
VARIABLE y2


: powerrect ( x1 y1 x2 y2 )
        ( 1 writemask )
        1 color         ( red )
        sboxfi
        ;

: groundrect ( x1 y1 x2 y2 )
        ( 2 writemask )
        7 color         ( white )
        sboxfi
        ;

: clearcircuit
        ( 3 writemask )
        0 color         ( black )
        clear
        ;

: initmain
        400 400 prefsize
        window winopen
        0 color
        clear
        48 qdevice      ( P )
        26 qdevice      ( G )
        28 qdevice      ( C )
         7 qdevice      ( ESC )
        542 qdevice     ( WINQUIT )
        103 qdevice     ( LEFTMOUSE )
        103 266 267 tie
        xorg yorg getorigin
        0 drawtype !
        ;

: main
        initmain
        BEGIN
                val qread CR DUP .
                ( DUP dev ! )
                DUP 542 =       ( WINQUIT )
                IF DROP EXIT THEN
                DUP 103 =       ( LEFTMOUSE )
                IF      x1  qread DROP
                        y1  qread DROP
                        val qread DROP
                        x2  qread DROP
                        y2  qread DROP
                        x1 W@ xorg @ -
                        y1 W@ yorg @ -
                        x2 W@ xorg @ -
                        y2 W@ yorg @ - .S
                        drawtype @ 1 =
                        IF      powerrect
                        ELSE    groundrect
                        THEN
                THEN
                val @ 0 =
                IF      DUP 48 =
                        IF 1 drawtype ! THEN
                        DUP 28 =
                        IF 2 drawtype ! THEN
                        DUP 26 =
                        IF clearcircuit THEN
                        DUP 7 =
                        IF DROP EXIT THEN
                THEN
                DROP
        AGAIN
        ;

main





































DECIMAL

INCLUDE man.f

( VARIABLE VAL )
( 103 qdevice )
 ( 103 266 267 tie )

: loop
        BEGIN
                ?KEY
                IF DUP 27 = ABORT" done"
                   CR ." key= " .
                THEN
        AGAIN
        ;


CR .( load lower.f )

( generate flowers in 3D )

DECIMAL

VARIABLE val
VARIABLE SCALE
VARIABLE x1
VARIABLE y1
VARIABLE x2
VARIABLE y2
VARIABLE z2

CREATE padelColor $F0F0F0 , $C0C0F0 , $9090F0 , $6060F0 , $3030F0 ,
CREATE padelR   20 , 40 , 60 , 80 , 100 ,
CREATE padelZ   20 , 30 , 40 , 40 , 30 ,
CREATE meshes 120 ALLOT


VARIABLE padels
8 padels !

VARIABLE padelSIN
VARIABLE padelCOS

: SIN@ ( a - n )
        @ FLOAT padelSIN @ F* INT
        ;

: COS@ ( a - n )
        @ FLOAT padelCOS @ F* INT
        ;

: fillMeshes
        PI padels @ FLOAT F/ 2.0 F* 
        DUP FSIN padelSIN !
        FCOS padelCOS !
        meshes 0 OVER ! CELL+ 0 OVER ! CELL+ 0 OVER !
        CELL+ padelR @ OVER ! CELL+ 0 OVER ! CELL+ padelZ @ OVER !
        CELL+ padelR COS@ OVER ! CELL+ padelR SIN@ OVER ! CELL+ padelZ @ OVER !
        CELL+ padelR CELL+ @ OVER ! CELL+ 0 OVER ! CELL+ padelZ CELL+ @ OVER !
        CELL+ padelR CELL+ COS@ OVER ! CELL+ padelR CELL+ SIN@ OVER ! 
        CELL+ padelZ CELL+ @ OVER !
        CELL+ padelR 8 + @ OVER ! CELL+ 0 OVER ! CELL+ padelZ 8 + @ OVER !
        CELL+ padelR 8 + COS@ OVER ! CELL+ padelR 8 + SIN@ OVER ! 
        CELL+ padelZ 8 + @ OVER !
        CELL+ padelR 12 + @ OVER ! CELL+ 0 OVER ! CELL+ padelZ 12 + @ OVER !
        CELL+ padelR 12 + COS@ OVER ! CELL+ padelR 12 + SIN@ OVER ! 
        CELL+ padelZ 12 + @ OVER !
        CELL+ padelR 16 + COS@ OVER ! CELL+ padelR 16 + SIN@ 2/ OVER ! 
        CELL+ padelZ 16 + @ SWAP !
        ;

: padel bgntmesh
        padelColor @ cpack
        meshes  v3i
        meshes
        3 FOR   12 + DUP v3i
                12 + DUP v3i
                4 R@ - CELLS
                padelColor + @ cpack
        NEXT
        12 + v3i
        endtmesh
        ;

: flower
        padel
        padels @ 2 -
        FOR     3600 padel @ / 122 ( z ) rotate 
                padel
        NEXT
        ;

VARIABLE HEIGHT1
VARIABLE HEIGHT2
VARIABLE R1
VARIABLE R2
VARIABLE THETA

CREATE MESH1 0 , 0 , 0 ,
CREATE MESH2 0 , 0 , 0 ,


: FLAT  bgntmesh
        HEIGHT1 @ MESH1 8 + ! 
        HEIGHT2 @ MESH2 8 + !
        0.0 ( init angle ) 
        padels @ ( segments in a cirle )
        FOR
                DUP FSIN OVER FCOS
                DUP R1 @ F* INT 500 + MESH1 !
                OVER R1 @ F* INT 500 + MESH1 CELL+ !
                MESH1 v3i
                R2 @ F* INT 500 + MESH2 !
                R2 @ F* INT 500 + MESH2 CELL+ !
                MESH2 v3i
                THETA F+
        NEXT    DROP
        endtmesh
        ;

: FLOWER
        0.0 R1 ! 20 FLOAT R2 !
        0.0 HEIGHT1 ! 40 FLOAT HEIGHT2 !
        $F0F0F0 cpack FLAT
        20 FLOAT R1 ! 40 FLOAT R2 !
        40 FLOAT HEIGHT1 ! 60 FLOAT HEIGHT2 !
        $C0C0F0 cpack FLAT
        40 FLOAT R1 ! 60 FLOAT R2 !
        70 FLOAT HEIGHT1 ! 70 FLOAT HEIGHT2 !
        $9090F0 cpack FLAT
        60 FLOAT R1 ! 80 FLOAT R2 !
        70 FLOAT HEIGHT1 ! 60 FLOAT HEIGHT2 !
        $6060F0 cpack FLAT
        80 FLOAT R1 ! 100 FLOAT R2 !
        60 FLOAT HEIGHT1 ! 50 FLOAT HEIGHT2 !
        $3030F0 cpack FLAT
        ;

INCLUDE win.f

: init  ( ginit )
        1000 1000 prefsize
        window winopen
        RGBmode
(       1 zbuffer )
        gconfig
        $4000 cpack
        clear
(       zclear )
        103 qdevice ( left mouse )
          7 qdevice ( ESC )
        146 qdevice ( F1 )
        147 qdevice ( F2 )
        148 qdevice ( F3 )
        542 qdevice ( WINQUIT )
        103 266 267 tie
        PI 2.0 F* padels @ FLOAT F/ THETA !
        ;


: plotAll
        900 1.0 10.0 2000 FLOAT perspective 
        x2 W@ 500 - ABS y2 W@ 500 - ABS MAX z2 W!
        x2 W@ FLOAT y2 W@ FLOAT z2 W@ FLOAT
        500 FLOAT DUP 0.0 0 lookat
        CR x2 W@ . y2 W@ . z2 W@ .
        FLOWER
        ;

: main  init
        900 1.0 10.0 2000 FLOAT perspective 
        500 x2 W! 0 y2 W! 
        plotAll
        BEGIN   val qread CR DUP .
                DUP 542 =       ( WINQUIT )
                IF DROP EXIT THEN
                DUP 103 =       ( LEFTMOUSE )
                IF      x1  qread DROP
                        y1  qread DROP
                        val qread DROP
                        x2  qread DROP
                        y2  qread DROP
                        plotAll
                THEN
                val @ 0 =
                IF      DUP 7 =         ( ESC )
                        IF      ABORT" done"
                        THEN                    
                THEN
                DROP
        AGAIN
        gexit
        ;
        
        
: test  init fillMeshes
        900 1.0 10.0 2000 FLOAT perspective 
        500 FLOAT 0.0 0.0
        500 FLOAT DUP 0.0 0 lookat
        500 FLOAT DUP 0.0 translate
        flower
        ;


CR .( load Yin-yang )

DECIMAL

VARIABLE val
VARIABLE SCALE
VARIABLE x1
VARIABLE y1
VARIABLE x2
VARIABLE y2
VARIABLE z2


INCLUDE win.f

: init  ( ginit )
        1000 1000 prefsize
        window winopen
        RGBmode
        1 zbuffer 
        gconfig
        $4000 cpack
        clear
        zclear 
        103 qdevice ( left mouse )
          7 qdevice ( ESC )
        146 qdevice ( F1 )
        147 qdevice ( F2 )
        148 qdevice ( F3 )
        542 qdevice ( WINQUIT )
        103 266 267 tie
        ;


CREATE MESH1 0 , 0 , 0 ,
CREATE MESH2 0 , 0 , 0 ,

PI 36 FLOAT F/ CONSTANT THETA

VARIABLE HEIGHT1
VARIABLE HEIGHT2
VARIABLE R1
VARIABLE R2

: STEP  bgntmesh
        HEIGHT1 @ DUP MESH1 8 + ! 
        HEIGHT2 @ MESH2 8 + !
        0.0 ( init angle ) 72 ( segments in a cirle )
        FOR
                DUP FSIN OVER FCOS
                DUP R1 @ F* INT 500 + MESH1 !
                OVER R1 @ F* INT 500 + MESH1 CELL+ !
                MESH1 v3i
                R2 @ F* INT 500 + MESH2 !
                R2 @ F* INT 500 + MESH2 CELL+ !
                MESH2 v3i
                THETA F+
        NEXT    DROP
        endtmesh
        ;

CREATE radius 0 , 20 , 40 , 60 , 80 , 100 ,
CREATE height 0 , 40 , 70 , 80 , 90 , 90 ,

: circles
        4 FOR   4 R@ - CELLS
                radius OVER + @ FLOAT R1 !
                radius OVER + CELL+ @ FLOAT R2 !
                height OVER + @ HEIGHT1 !
                height OVER + CELL+ @ HEIGHT2 !
                R@ $202000 * $80 + cpack
                STEP
                -20 HEIGHT1 +!
                -20 HEIGHT2 +!
        NEXT    DROP
        ;


: plotAll
        $4000 cpack
        clear
        zclear
        900 1.0 10.0 2000 FLOAT perspective 
        x2 W@ 500 - ABS y2 W@ 500 - ABS MAX z2 W!
        x2 W@ FLOAT y2 W@ FLOAT z2 W@ FLOAT
        500 FLOAT DUP 0.0 0 lookat
        CR x2 W@ . y2 W@ . z2 W@ .
        circles
        ;

: test5 ( angle -- )
        init
        ( 0.0 500 FLOAT 0.0 OVER 0.0 OVER ortho )
        900 1.0 10.0 2000 FLOAT perspective 
        >R 500 FLOAT 0.0 OVER 500 FLOAT DUP 0.0 R> lookat 
        plotAll
        10 sleep
        gexit
        ;
        
: main  init
        900 1.0 10.0 2000 FLOAT perspective 
        500 x2 W! 0 y2 W! 
        plotAll
        BEGIN   val qread CR DUP .
                DUP 542 =       ( WINQUIT )
                IF DROP EXIT THEN
                DUP 103 =       ( LEFTMOUSE )
                IF      x1  qread DROP
                        y1  qread DROP
                        val qread DROP
                        x2  qread DROP
                        y2  qread DROP
                        plotAll
                THEN
                val @ 0 =
                IF      DUP 7 =         ( ESC )
                        IF      ABORT" done"
                        THEN                    
                THEN
                DROP
        AGAIN
        gexit
        ;
        
main    
( benchmark routines, 9/01/93 cht )

: looptests ( n -- )
        FOR 1000000 FOR NEXT NEXT ;
: +test ( -- )
        1000000 FOR R@ DUP + DROP NEXT ;
: *test ( -- )
        1000000 FOR R@ DUP * DROP NEXT ;
: /test ( -- )
        1000000 FOR 1000000 R@ / DROP NEXT ;
( Mandelbrot plots, cht 08/20/93 )


( Execute initPlot to get a window              )
( Execute main to enter the main control loop   )
( Use mouse to point to a point of interest     )
( Use F1 to zoom in by a factor of 2            )
( Use F2 to zoom out by a factor of 2           )
( Use F3 to get the initial plot                )
( Use ESC to exit the main loop                 )
( Execute gexit to close the window             )


DECIMAL

INCLUDE win.f ( need this to init graphic system)

DECIMAL

CREATE XY 0 , 0 ,
CREATE CENTER 0 , 0 ,
CREATE ORIGIN 0 , 0 ,
CREATE SIZE 0 , 0 ,


VARIABLE val
VARIABLE SCALE
VARIABLE x1
VARIABLE y1
VARIABLE x2
VARIABLE y2


: initPlot ( init window and parameters )
        400 400 prefsize
        window winopen
        BLACK color
        clear
        $400000 SCALE !
        0 $F0000000 CENTER 2!
        ORIGIN DUP CELL+ getorigin
        SIZE DUP CELL+ getsize
        103 qdevice ( left mouse )
          7 qdevice ( ESC )
        146 qdevice ( F1 )
        147 qdevice ( F2 )
        148 qdevice ( F3 )
        542 qdevice ( WINQUIT )
        103 266 267 tie
        ;

: man   ( do a Mandelbrot plot )
        bgnpoint 
        CENTER CELL+ @ 
        SCALE @ SIZE CELL+ @ 2 */ -     ( init y in m-space)
        SIZE CELL+ @ 1 - 
        FOR     CENTER @ SCALE @ 
                SIZE @ 2 */ -           ( init x in m-space)
                R@ XY CELL+ !           ( init x in plot )
                SIZE @ 1 - 
                FOR     2DUP
                        64 SWAP ROT
                        MANDEL 
                        ( .S KEY 27 = ABORT" DONE" )
                        15 AND  ( compute color)
                        color   
                        SIZE @ R@ - XY !
                        XY v2i          ( plot one point )
                        SCALE @ +       ( bump x )
                NEXT    
                DROP
                SCALE @ +               ( bump y )
        NEXT
        DROP
        endpoint
        qreset CR SCALE ? CENTER 2@ . .
        ;


: shift x2 W@ ORIGIN @ - 200 - SCALE @ * CENTER +!
        y2 W@ ORIGIN CELL+ @ - 200 - SCALE @ * 
        NEGATE CENTER CELL+ +!
        ;


: main  ( main control loop )
        initPlot
        qreset man
        BEGIN   val qread CR DUP .
                DUP 542 =       ( WINQUIT )
                IF DROP EXIT THEN
                DUP 103 =       ( LEFTMOUSE )
                IF      x1  qread DROP
                        y1  qread DROP
                        val qread DROP
                        x2  qread DROP
                        y2  qread DROP
                        shift man
                THEN
                val @ 0 =
                IF      DUP 7 =         ( ESC )
                        IF      ABORT" done"
                        THEN                    
                        DUP 146 =       ( F1 )
                        IF      SCALE @ 2 / 1 MAX
                                SCALE ! man
                        THEN                    
                        DUP 147 =       ( F2 )
                        IF      SCALE @ 2 * $800000 MIN
                                SCALE ! man
                        THEN                    
                        DUP 148 =       ( F3 )
                        IF      $400000 SCALE !
                                0 $F0000000 CENTER 2!
                                man
                        THEN
                THEN
                DROP
        AGAIN
        ;

main
( Mandelbrot plots, cht 08/20/93 )

INCLUDE win.f

CREATE XY 0 , 0 ,
CREATE CENTER 200 , 200 ,
VARIABLE SCALE

: initPlot
        400 400 prefsize
        window winopen
        BLACK color
        clear
        $10000000 400 /
        SCALE !
        0 0 CENTER 2!
        ;

: plotMandelbrot
        bgnpoint
        CENTER 4 + @ SCALE @ 200 * -    ( init y in m-space)
        399 FOR CENTER @ SCALE @ 200 * - ( init x in m-space)
                R@ XY 4 + !             ( init x in plot )
                399 FOR 2DUP >R
                        64 SWAP R>
                        MANDEL 
                        ( .S KEY 27 = ABORT" DONE" )
                        15 AND  ( compute color)
                        color   
                        R@ XY !
                        XY v2i          ( plot one point )
                        SCALE @ +       ( bump x )
                NEXT    
                DROP
                SCALE @ +               ( bump y )
        NEXT
        DROP
        endpoint
        ;
                
                        
        
: plotTest
        bgnpoint
        399 FOR
        R@ XY 4 + !
        399 FOR
        R@ XY !
        R@ 8 / color
        XY v2i
        NEXT
        NEXT
        endpoint
        ;gexit( circuit drawing, converted from circuit.c )
( cht 8/22/93 )

DECIMAL
INCLUDE win.f

DECIMAL

VARIABLE xorg
VARIABLE yorg
VARIABLE drawtype
VARIABLE dev
VARIABLE val
VARIABLE x1
VARIABLE y1
VARIABLE x2
VARIABLE y2


: powerrect ( x1 y1 x2 y2 )
        ( 1 writemask )
        1 color         ( red )
        sboxfi
        ;

: groundrect ( x1 y1 x2 y2 )
        ( 2 writemask )
        7 color         ( white )
        sboxfi
        ;

: clearcircuit
        ( 3 writemask )
        0 color         ( black )
        clear
        ;

: initmain
        400 400 prefsize
        window winopen
        RGBmode
        gconfig
        0 color
        clear
        48 qdevice      ( P )
        26 qdevice      ( G )
        28 qdevice      ( C )
         7 qdevice      ( ESC )
        542 qdevice     ( WINQUIT )
        103 qdevice     ( LEFTMOUSE )
        103 266 267 tie
        xorg yorg getorigin
        0 drawtype !
        ;

: mainloop
        BEGIN
                val qread CR DUP .
                ( DUP dev ! )
                DUP 542 =       ( WINQUIT )
                IF DROP EXIT THEN
                DUP 103 =       ( LEFTMOUSE )
                IF      x1  qread DROP
                        y1  qread DROP
                        val qread DROP
                        x2  qread DROP
                        y2  qread DROP
                        x1 W@ xorg @ -
                        y1 W@ yorg @ -
                        x2 W@ xorg @ -
                        y2 W@ yorg @ - .S
                        drawtype @ 1 =
                        IF      powerrect
                        ELSE    groundrect
                        THEN
                THEN
                val @ 0 =
                IF      DUP 48 =
                        IF 1 drawtype ! THEN
                        DUP 28 =
                        IF 2 drawtype ! THEN
                        DUP 26 =
                        IF clearcircuit THEN
                        DUP 7 =
                        IF DROP EXIT THEN
                THEN
                DROP
        AGAIN
        ;

VARIABLE minimum

: iteration ( x y n -- )
        2/ DUP
        ( .S KEY 27 = ABORT" done")
        minimum @ < 
        IF      ( .S )
                DROP
                pnt2i
                EXIT 
        THEN
        >R
        2DUP R@ 2/ + R@ RECURSE 
        2DUP R@ 2/ - R@ RECURSE 
        SWAP R@ + SWAP R> RECURSE
        ;
                
: tree  initmain
        4 minimum !
        WHITE color
        100 100 100 iteration
        ;

VARIABLE ANGLE1
VARIABLE ANGLE2
VARIABLE ANGLE3
VARIABLE SCALE1
VARIABLE SCALE2
VARIABLE SCALE3
VARIABLE YINC1
VARIABLE YINC2
VARIABLE YINC3
90 CONSTANT Z
VARIABLE LEAVES
VARIABLE TRUNK

: generate ( n -- )
        ( .S KEY 27 = ABORT" done" )
        1 - DUP 0<
        IF      DROP 
                LEAVES @ cpack
                0 0 move2i
                0 4 draw2i 
                TRUNK @ cpack
                EXIT 
        THEN

        >R ( n )
        0 0 move2i 
        0 YINC1 @ draw2i

        pushmatrix ( trunk )
        0.0 YINC1 @ FLOAT 0.0 translate
        ANGLE1 @ Z rotate
        SCALE1 @ DUP 1.0 scale
        R@ RECURSE
        popmatrix

        pushmatrix ( left branch )
        0.0 YINC2 @ FLOAT 0.0 translate
        ANGLE2 @ Z rotate
        SCALE2 @ DUP 1.0 scale
        R@ RECURSE
        popmatrix

        pushmatrix ( right branch )
        0.0 YINC3 @ FLOAT 0.0 translate
        ANGLE3 @ Z rotate
        SCALE3 @ DUP 1.0 scale
        R> RECURSE
        popmatrix
        
        ;

: fernTest
        100 ANGLE1 !
        400 ANGLE2 !
        3300 ANGLE3 !

        8 FLOAT 10.0 F/ SCALE1 !
        4 FLOAT 10.0 F/ SCALE2 !
        3 FLOAT 10.0 F/ SCALE3 !

        40 YINC1 !
        30 YINC2 !
        20 YINC3 !

        initmain 
        $008000 LEAVES !
        $302080 TRUNK ! 
        TRUNK @ cpack
        pushmatrix
        200 FLOAT 0.0 0.0 translate
        10 generate 
        popmatrix
        ;

: ferns 100 ANGLE1 ! 400 ANGLE2 ! 3300 ANGLE3 !
        8 FLOAT 10.0 F/ SCALE1 !
        4 FLOAT 10.0 F/ SCALE2 !
        3 FLOAT 10.0 F/ SCALE3 !
        30 YINC1 !  20 YINC2 !  10 YINC3 !
        $8000 LEAVES !
        $302080 TRUNK !
        50 FLOAT 0.0 0.0 translate 10 generate
        30 FLOAT 50 FLOAT 0.0 translate 8 generate
        200 ANGLE1 !
        50 FLOAT -50 FLOAT 0.0 translate 9 generate
        3500 ANGLE1 ! 10 YINC2 ! 20 YINC3 !
        10 FLOAT 50 FLOAT 0.0 translate 11 generate
        ;

: pines 0 ANGLE1 ! 600 ANGLE2 ! 3000 ANGLE3 !
        8 FLOAT 10.0 F/ SCALE1 !
        2 FLOAT 10.0 F/ SCALE2 !
        2 FLOAT 10.0 F/ SCALE3 !
        40 YINC1 !  40 YINC2 !  20 YINC3 !
        $4000 LEAVES !
        $202020 TRUNK !
        TRUNK @ cpack
        50 FLOAT 150 FLOAT 0.0 translate 10 generate
        40 FLOAT 10 FLOAT 0.0 translate 10 generate
        50 FLOAT 50 FLOAT 0.0 translate 8 generate
        30 FLOAT -100 FLOAT 0.0 translate 10 generate
        ;

: walnut        100 ANGLE1 ! 300 ANGLE2 ! 3400 ANGLE3 !
        4 FLOAT 10.0 F/ SCALE1 !
        8 FLOAT 10.0 F/ SCALE2 !
        8 FLOAT 10.0 F/ SCALE3 !
        50 YINC1 !  50 YINC2 !  50 YINC3 !
        $F000 LEAVES !
        $402040 TRUNK !
        TRUNK @ cpack
        180 FLOAT 30 FLOAT 0.0 translate 10 generate
        ;

: trees initmain
        $0 cpack
        clear
        pushmatrix 
        pines
        popmatrix
        pushmatrix
        180 FLOAT 30 FLOAT 0.0 translate
        pines
        popmatrix
        pushmatrix 
        walnut
        popmatrix
        pushmatrix 
        ferns
        popmatrix
        pushmatrix
        200 FLOAT 20 FLOAT 0.0 translate
        ferns
        popmatrix
        
        ;

trees






















: walnuts       100 ANGLE1 ! 300 ANGLE2 ! 3400 ANGLE3 !
        4 FLOAT 10.0 F/ SCALE1 !
        8 FLOAT 10.0 F/ SCALE2 !
        8 FLOAT 10.0 F/ SCALE3 !
        50 YINC1 !  50 YINC2 !  50 YINC3 !
        $F000 LEAVES !
        $402040 TRUNK !
        TRUNK @ cpack
        200 FLOAT 100 FLOAT 0.0 translate 10 generate
        ;

CR .( load window test )

CREATE array 200 , 100 , 100 , 300 , 200 , 500 ,
        400 , 500 , 500 , 300 , 400 , 100 ,

: graph
        ginit
        BLACK color
        clear
        GREEN color
        6 array polf2i
        BLUE color
        1000 600 200 circfi
        RED color
        100 600 300 800 rectfi
        YELLOW color
        500 600 100 0 800 arcfi 
        CYAN color
        500 600 100 800 1200 arcfi      
        MAGENTA color
        500 600 100 1200 2200 arcfi     
        BLUE color
        500 600 100 2200 0 arcfi
        WHITE color
        1000 200 cmov2i
        $" C. H. Ting"
        1 + charstr
        1 sleep 
        gexit

        ;

CR .( window test loaded. )

graph

CR .( load Yin-yang )


: init  ginit
        BLACK color
        clear
        ;

: yinyang
        WHITE color
        500 500 120 0 1800 arcfi
        BLACK color
        500 500 120 1800 0 arcfi
        WHITE color
        440 500 60 circfi
        BLACK color
        560 500 60 circfi
        WHITE color
        560 500 20 circfi
        BLACK color
        440 500 20 circfi
        ;

: trigrams
        BLUE color
        500 500 480 circfi

        WHITE color
        500 500 480    0  225 arcfi
        500 500 480  450  675 arcfi
        500 500 480  900 1125 arcfi
        500 500 480 1350 1575 arcfi

        500 500 480 1800 1875 arcfi
        500 500 480 1950 2025 arcfi
        500 500 480 2250 2325 arcfi
        500 500 480 2400 2475 arcfi

        500 500 480 2700 2775 arcfi
        500 500 480 2850 2925 arcfi
        500 500 480 3150 3225 arcfi
        500 500 480 3300 3375 arcfi
        
        BLUE color
        500 500 450 circfi

        WHITE color
        500 500 420    0  225 arcfi
        500 500 420  450  675 arcfi
        500 500 420 2700 2925 arcfi
        500 500 420 3150 3375 arcfi

        500 500 420  900  975 arcfi
        500 500 420 1050 1125 arcfi
        500 500 420 1350 1425 arcfi
        500 500 420 1500 1575 arcfi

        500 500 420 1800 1875 arcfi
        500 500 420 1950 2025 arcfi
        500 500 420 2250 2325 arcfi
        500 500 420 2400 2475 arcfi
        
        BLUE color
        500 500 390 circfi

        WHITE color
        500 500 360    0  225 arcfi
        500 500 360  900 1125 arcfi
        500 500 360 2250 2475 arcfi
        500 500 360 3150 3375 arcfi

        500 500 360  450  525 arcfi
        500 500 360  600  675 arcfi
        500 500 360 1350 1425 arcfi
        500 500 360 1500 1575 arcfi

        500 500 360 1800 1875 arcfi
        500 500 360 1950 2025 arcfi
        500 500 360 2700 2775 arcfi
        500 500 360 2850 2925 arcfi

        BLUE color
        500 500 330 circfi
        ;

: test init trigrams yinyang 5 sleep gexit ;




CR .( load Yin-yang )

: init  ginit
        BLACK color
        clear
        ;

: yingyang
        WHITE color
        500 500 120 0 1800 arcfi
        BLACK color
        500 500 120 1800 0 arcfi
        WHITE color
        440 500 60 circfi
        BLACK color
        560 500 60 circfi
        WHITE color
        560 500 20 circfi
        BLACK color
        440 500 20 circfi
        ;


: circles
        BLUE color
        500 500 480 circfi
        BLACK color
        500 500 460 circi
        BLACK color
        500 500 440 circi
        BLACK color
        500 500 420 circi
        BLACK color
        500 500 400 circi
        BLACK color
        500 500 380 circi
        BLACK color
        500 500 360 circi
        BLACK color
        500 500 340 circi
        BLACK color
        500 500 320 circi
        BLACK color
        500 500 300 circi
        ;

: yang  WHITE color
        -100 -4 100 4 rectfi
        ;

: ying  WHITE color
        -100 -4 -20 4 rectfi
        20 -4 100 4 rectfi
        ;

: octagrams
        pushmatrix
        500 FLOAT DUP 0.0 translate

        pushmatrix
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT 0.0 translate
        yang
        popmatrix

        pushmatrix
        450 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT 0.0 translate
        ying
        popmatrix

        pushmatrix
        900 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT 0.0 translate
        yang
        popmatrix

        pushmatrix
        1350 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT 0.0 translate
        ying
        popmatrix

        pushmatrix
        1800 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT 0.0 translate
        ying
        popmatrix

        pushmatrix
        2250 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT 0.0 translate
        yang
        popmatrix

        pushmatrix
        2700 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT 0.0 translate
        ying
        popmatrix

        pushmatrix
        3150 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT 0.0 translate
        yang
        popmatrix

        popmatrix
        ;

: test2 init 
        circles
        yingyang
        octagrams
        10 sleep
        gexit
        ;
        
        
        
CR .( load Yin-yang )

DECIMAL

CREATE topyang -100 , -4 , 40 , 100 , -4 , 40 ,
                100 , 4 , 40 , -100 , 4 , 40 ,
CREATE botyang -100 , -4 , 0 , 100 , -4 , 0 ,
                100 , 4 , 0 , -100 , 4 , 0 ,
CREATE foryang -100 , -4 , 0 , 100 , -4 , 0 ,
                100 , -4 , 40 , -100 , -4 , 40 ,
CREATE bacyang -100 , 4 , 0 , 100 , 4 , 0 ,
                100 , 4 , 40 , -100 , 4 , 40 ,
CREATE lefyang -100 , -4 , 0 , -100 , 4 , 0 ,
                -100 , 4 , 40 , -100 , -4 , 40 ,
CREATE rigyang  100 , -4 , 0 , 100 , 4 , 0 ,
                100 , 4 , 40 , 100 , -4 , 40 ,

CREATE topying1 -100 , -4 , 40 , -20 , -4 , 40 ,
                -20 , 4 , 40 , -100 , 4 , 40 ,
CREATE botying1 -100 , -4 , 0 , -20 , -4 , 0 ,
                -20 , 4 , 0 , -100 , 4 , 0 ,
CREATE forying1 -100 , -4 , 0 , -20 , -4 , 0 ,
                -20 , -4 , 40 , -100 , -4 , 40 ,
CREATE bacying1 -100 , 4 , 0 , -20 , 4 , 0 ,
                -20 , 4 , 40 , -100 , 4 , 40 ,
CREATE lefying1 -100 , -4 , 0 , -100 , 4 , 0 ,
                -100 , 4 , 40 , -100 , -4 , 40 ,
CREATE rigying1  -20 , -4 , 0 , -20 , 4 , 0 ,
                -20 , 4 , 40 , -20 , -4 , 40 ,

CREATE topying2 20 , -4 , 40 , 100 , -4 , 40 ,
                100 , 4 , 40 , 20 , 4 , 40 ,
CREATE botying2 20 , -4 , 0 , 100 , -4 , 0 ,
                100 , 4 , 0 , 20 , 4 , 0 ,
CREATE forying2 20 , -4 , 0 , 100 , -4 , 0 ,
                100 , -4 , 40 , 20 , -4 , 40 ,
CREATE bacying2 20 , 4 , 0 , 100 , 4 , 0 ,
                100 , 4 , 40 , 20 , 4 , 40 ,
CREATE lefying2 20 , -4 , 0 , 20 , 4 , 0 ,
                20 , 4 , 40 , 20 , -4 , 40 ,
CREATE rigying2  100 , -4 , 0 , 100 , 4 , 0 ,
                100 , 4 , 40 , 100 , -4 , 40 ,


: init  ginit
        RGBmode
        gconfig
        ( 1 zbuffer
        zclear )
        $4040 cpack
        clear
        ;

: yingyang
        $FFFFFF cpack
        500 500 120 0 1800 arcfi
        0 cpack
        500 500 120 1800 0 arcfi
        $FFFFFF cpack
        440 500 60 circfi
        $0 cpack
        560 500 60 circfi
        $FFFFFF cpack
        560 500 20 circfi
        0 cpack
        440 500 20 circfi
        ;


: circles
        $200000 cpack
        500 500 500 circfi
        $800000 cpack
        500 500 500 circfi
        $FF0000 cpack
        500 500 460 circfi
        $E00000 cpack
        500 500 440 circfi
        $C00000 cpack
        500 500 400 circfi
        $A00000 cpack
        500 500 360 circfi
        $800000 cpack
        500 500 320 circfi
        $600000 cpack
        500 500 280 circfi
        $400000 cpack
        500 500 240 circfi
        $200000 cpack
        500 500 200 circfi

        0 cpack
        500 500 480 circi
        500 500 460 circi
        500 500 440 circi
        500 500 420 circi
        500 500 400 circi
        500 500 380 circi
        500 500 360 circi
        500 500 340 circi
        500 500 320 circi
        500 500 300 circi
        500 500 280 circi
        500 500 260 circi
        500 500 240 circi
        500 500 220 circi
        500 500 200 circi
        ;

: yang  $E0E0E0 cpack
        4 topyang polfi
        $C0C0C0 cpack
        4 foryang polfi
        $C0C0C0 cpack
        4 bacyang polfi
        $A0A0A0 cpack
        4 lefyang polfi
        $A0A0A0 cpack
        4 rigyang polfi
        ( $E0E0E0 cpack )
        ( 4 botyang polfi )
        ;

: ying  $E0E0E0 cpack
        4 topying1 polfi
        $C0C0C0 cpack
        4 forying1 polfi
        $C0C0C0 cpack
        4 bacying1 polfi
        $A0A0A0 cpack
        4 lefying1 polfi
        $A0A0A0 cpack
        4 rigying1 polfi
        ( $E0E0E0 cpack )
        ( 4 botying1 polfi )
        $E0E0E0 cpack
        4 topying2 polfi
        $C0C0C0 cpack
        4 forying2 polfi
        $C0C0C0 cpack
        4 bacying2 polfi
        $A0A0A0 cpack
        4 lefying2 polfi
        $A0A0A0 cpack
        4 rigying2 polfi
        ( $E0E0E0 cpack )
        ( 4 botying2 polfi )
        ;

: octagrams
        pushmatrix
        500 FLOAT DUP 0.0 translate

        pushmatrix
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT DUP translate
        yang
        0.0 -40 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        450 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT DUP translate
        yang
        0.0 -40 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        900 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT DUP translate
        ying
        0.0 -40 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        1350 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -40 FLOAT DUP translate
        ying
        0.0 -40 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        1800 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT DUP translate
        ying
        0.0 -40 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        2250 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT DUP translate
        ying
        0.0 -40 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        2700 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT DUP translate
        yang
        0.0 -40 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        3150 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -40 FLOAT DUP translate
        yang
        0.0 -40 FLOAT DUP translate
        yang
        popmatrix

        popmatrix
        ;

: test3 init 
        circles
        yingyang
        octagrams
        10 sleep 
        gexit
        ;

: test4 ( angle -- )
        >R
        init
        900 1.0 10.0 2000 FLOAT perspective
        500 FLOAT 0.0 OVER 500 FLOAT DUP 0.0 R> lookat
        circles
        octagrams
        0 zbuffer
        yingyang
        10 sleep
        gexit
        ;

: cylinder ( radius -- )
        >R
        $800000 cpack
        500 500 R@ circfi
        0 cpack
        500 500 R> 20 - circfi
        ;

: cylinders 
        500
        9 FOR   DUP cylinder
                0.0 0.0 10.0 translate
                20 -
        NEXT
        DROP
        ;

: test5 ( angle -- )
        >R
        init
        900 1.0 10.0 2000 FLOAT perspective
        500 FLOAT 0.0 OVER 500 FLOAT DUP 0.0 R> lookat
        pushmatrix
        cylinders
        yingyang
        popmatrix
        10 sleep
        gexit
        ;

        
        
        
CR .( load Yin-yang )

DECIMAL

VARIABLE val
VARIABLE SCALE
VARIABLE x1
VARIABLE y1
VARIABLE x2
VARIABLE y2
VARIABLE z2

CREATE topyang -100 , -2 , 20 , 100 , -2 , 20 ,
                100 , 2 , 20 , -100 , 2 , 20 ,
CREATE botyang -100 , -2 , 0 , 100 , -2 , 0 ,
                100 , 2 , 0 , -100 , 2 , 0 ,
CREATE foryang -100 , -2 , 0 , 100 , -2 , 0 ,
                100 , -2 , 20 , -100 , -2 , 20 ,
CREATE bacyang -100 , 2 , 0 , 100 , 2 , 0 ,
                100 , 2 , 20 , -100 , 2 , 20 ,
CREATE lefyang -100 , -2 , 0 , -100 , 2 , 0 ,
                -100 , 2 , 20 , -100 , -2 , 20 ,
CREATE rigyang  100 , -2 , 0 , 100 , 2 , 0 ,
                100 , 2 , 20 , 100 , -2 , 20 ,

CREATE topying1 -100 , -2 , 20 , -20 , -2 , 20 ,
                -20 , 2 , 20 , -100 , 2 , 20 ,
CREATE botying1 -100 , -2 , 0 , -20 , -2 , 0 ,
                -20 , 2 , 0 , -100 , 2 , 0 ,
CREATE forying1 -100 , -2 , 0 , -20 , -2 , 0 ,
                -20 , -2 , 20 , -100 , -2 , 20 ,
CREATE bacying1 -100 , 2 , 0 , -20 , 2 , 0 ,
                -20 , 2 , 20 , -100 , 2 , 20 ,
CREATE lefying1 -100 , -2 , 0 , -100 , 2 , 0 ,
                -100 , 2 , 20 , -100 , -2 , 20 ,
CREATE rigying1  -20 , -2 , 0 , -20 , 2 , 0 ,
                -20 , 2 , 20 , -20 , -2 , 20 ,

CREATE topying2 20 , -2 , 20 , 100 , -2 , 20 ,
                100 , 2 , 20 , 20 , 2 , 20 ,
CREATE botying2 20 , -2 , 0 , 100 , -2 , 0 ,
                100 , 2 , 0 , 20 , 2 , 0 ,
CREATE forying2 20 , -2 , 0 , 100 , -2 , 0 ,
                100 , -2 , 20 , 20 , -2 , 20 ,
CREATE bacying2 20 , 2 , 0 , 100 , 2 , 0 ,
                100 , 2 , 20 , 20 , 2 , 20 ,
CREATE lefying2 20 , -2 , 0 , 20 , 2 , 0 ,
                20 , 2 , 20 , 20 , -2 , 20 ,
CREATE rigying2  100 , -2 , 0 , 100 , 2 , 0 ,
                100 , 2 , 20 , 100 , -2 , 20 ,

INCLUDE win.f

: init  ( ginit )
        1000 1000 prefsize
        window winopen
        RGBmode
(       1 zbuffer )
        gconfig
        $4000 cpack
        clear
(       zclear )
        103 qdevice ( left mouse )
          7 qdevice ( ESC )
        146 qdevice ( F1 )
        147 qdevice ( F2 )
        148 qdevice ( F3 )
        542 qdevice ( WINQUIT )
        103 266 267 tie
        ;

: yingyang
        pushmatrix
        0.0 0.0 40 FLOAT translate
        $FFFFFF cpack
        500 500 120 0 1800 arcfi
        0 cpack
        500 500 120 1800 0 arcfi
        $FFFFFF cpack
        440 500 60 circfi
        $0 cpack
        560 500 60 circfi
        $FFFFFF cpack
        560 500 20 circfi
        0 cpack
        440 500 20 circfi
        popmatrix
        ;


CREATE MESH1 0 , 0 , 0 ,
CREATE MESH2 0 , 0 , 0 ,

PI 36 FLOAT F/ CONSTANT THETA

VARIABLE HEIGHT1
VARIABLE HEIGHT2
VARIABLE R1
VARIABLE R2

: FLAT  bgntmesh
        HEIGHT1 @ DUP MESH1 8 + ! MESH2 8 + !
        0.0 ( init angle ) 72 ( segments in a cirle )
        FOR
                DUP FSIN OVER FCOS
                DUP R1 @ F* INT 500 + MESH1 !
                OVER R1 @ F* INT 500 + MESH1 CELL+ !
                MESH1 v3i
                R2 @ F* INT 500 + MESH2 !
                R2 @ F* INT 500 + MESH2 CELL+ !
                MESH2 v3i
                THETA F+
        NEXT    DROP
        endtmesh
        ;

: STEP  bgntmesh
        HEIGHT1 @ MESH1 8 + ! 
        HEIGHT2 @ MESH2 8 + !
        0.0 ( init angle ) 72 ( segments in a cirle )
        FOR     
                DUP FSIN OVER FCOS
                R2 @ F* INT 500 + DUP MESH1 ! MESH2 !
                R2 @ F* INT 500 + DUP
                MESH1 CELL+ ! MESH2 CELL+ !
                MESH1 v3i
                MESH2 v3i
                THETA F+
        NEXT    DROP
        endtmesh
        ;

: shade 
        $4040 cpack
        bgntmesh
        130 MESH1 8 + ! 0 MESH2 8 + !
        480 FLOAT R1 ! 600 FLOAT R2 !
        0.0 ( init angle ) 72 ( segments in a cirle )
        FOR
                DUP FSIN OVER FCOS
                DUP R1 @ F* INT 500 + MESH1 !
                OVER R1 @ F* INT 500 + MESH1 CELL+ !
                MESH1 v3i
                R2 @ F* INT 500 + MESH2 !
                R2 @ F* INT 500 + MESH2 CELL+ !
                MESH2 v3i
                THETA F+
        NEXT    DROP
        endtmesh
        ;

: circles
        130 HEIGHT1 ! 120 HEIGHT2 !
        480
        14 FOR  DUP FLOAT R1 !
                10 - DUP FLOAT R2 !
                $C00000 cpack
                FLAT
                $000000 cpack
                STEP
                -10 HEIGHT1 +!
                -10 HEIGHT2 +!
        NEXT    DROP
        ;

: steps
        40 HEIGHT1 ! 30 HEIGHT2 !
        120
        3 FOR   DUP FLOAT R1 !
                10 + DUP FLOAT R2 !
                $808080 cpack
                FLAT
                $000000 cpack
                STEP
                -10 HEIGHT1 +!
                -10 HEIGHT2 +!
        NEXT    DROP
        ;

        
: yang  $E0E0E0 cpack
        4 topyang polfi
        $C0C0C0 cpack
        4 foryang polfi
        $C0C0C0 cpack
        4 bacyang polfi
        $A0A0A0 cpack
        4 lefyang polfi
        $A0A0A0 cpack
        4 rigyang polfi
        ( $E0E0E0 cpack )
        ( 4 botyang polfi )
        ;

: ying  $E0E0E0 cpack
        4 topying1 polfi
        $C0C0C0 cpack
        4 forying1 polfi
        $C0C0C0 cpack
        4 bacying1 polfi
        $A0A0A0 cpack
        4 lefying1 polfi
        $A0A0A0 cpack
        4 rigying1 polfi
        ( $E0E0E0 cpack )
        ( 4 botying1 polfi )
        $E0E0E0 cpack
        4 topying2 polfi
        $C0C0C0 cpack
        4 forying2 polfi
        $C0C0C0 cpack
        4 bacying2 polfi
        $A0A0A0 cpack
        4 lefying2 polfi
        $A0A0A0 cpack
        4 rigying2 polfi
        ( $E0E0E0 cpack )
        ( 4 botying2 polfi )
        ;

: octagrams
        pushmatrix
        500 FLOAT DUP 120 FLOAT translate

        pushmatrix
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -20 FLOAT DUP translate
        yang
        0.0 -20 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        450 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -20 FLOAT DUP translate
        yang
        0.0 -20 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        900 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -20 FLOAT DUP translate
        ying
        0.0 -20 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        1350 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -20 FLOAT DUP translate
        ying
        0.0 -20 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        1800 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -20 FLOAT DUP translate
        ying
        0.0 -20 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        2250 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -20 FLOAT DUP translate
        ying
        0.0 -20 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        2700 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -20 FLOAT DUP translate
        yang
        0.0 -20 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        3150 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -20 FLOAT DUP translate
        yang
        0.0 -20 FLOAT DUP translate
        yang
        popmatrix

        popmatrix
        ;

: plotAll
        900 1.0 10.0 2000 FLOAT perspective 
        x2 W@ 500 - ABS y2 W@ 500 - ABS MAX z2 W!
        x2 W@ FLOAT y2 W@ FLOAT z2 W@ FLOAT
        500 FLOAT DUP 0.0 0 lookat
        CR x2 W@ . y2 W@ . z2 W@ .
        $4000 cpack clear
        shade
        circles
        steps
        yingyang
        octagrams
        ;

: test5 ( angle -- )
        init
        ( 0.0 500 FLOAT 0.0 OVER 0.0 OVER ortho )
        900 1.0 10.0 2000 FLOAT perspective 
        >R 500 FLOAT 0.0 OVER 500 FLOAT DUP 0.0 R> lookat 
        plotAll
        10 sleep
        gexit
        ;
        
: main  init
        900 1.0 10.0 2000 FLOAT perspective 
        500 x2 W! 0 y2 W! 
        plotAll
        BEGIN   val qread CR DUP .
                DUP 542 =       ( WINQUIT )
                IF DROP EXIT THEN
                DUP 103 =       ( LEFTMOUSE )
                IF      x1  qread DROP
                        y1  qread DROP
                        val qread DROP
                        x2  qread DROP
                        y2  qread DROP
                        plotAll
                THEN
                val @ 0 =
                IF      DUP 7 =         ( ESC )
                        IF      ABORT" done"
                        THEN                    
                THEN
                DROP
        AGAIN
        gexit
        ;
        
main    
CR .( load Yin-yang )

DECIMAL

CREATE topyang -100 , -2 , 20 , 100 , -2 , 20 ,
                100 , 2 , 20 , -100 , 2 , 20 ,
CREATE botyang -100 , -2 , 0 , 100 , -2 , 0 ,
                100 , 2 , 0 , -100 , 2 , 0 ,
CREATE foryang -100 , -2 , 0 , 100 , -2 , 0 ,
                100 , -2 , 20 , -100 , -2 , 20 ,
CREATE bacyang -100 , 2 , 0 , 100 , 2 , 0 ,
                100 , 2 , 20 , -100 , 2 , 20 ,
CREATE lefyang -100 , -2 , 0 , -100 , 2 , 0 ,
                -100 , 2 , 20 , -100 , -2 , 20 ,
CREATE rigyang  100 , -2 , 0 , 100 , 2 , 0 ,
                100 , 2 , 20 , 100 , -2 , 20 ,

CREATE topying1 -100 , -2 , 20 , -20 , -2 , 20 ,
                -20 , 2 , 20 , -100 , 2 , 20 ,
CREATE botying1 -100 , -2 , 0 , -20 , -2 , 0 ,
                -20 , 2 , 0 , -100 , 2 , 0 ,
CREATE forying1 -100 , -2 , 0 , -20 , -2 , 0 ,
                -20 , -2 , 20 , -100 , -2 , 20 ,
CREATE bacying1 -100 , 2 , 0 , -20 , 2 , 0 ,
                -20 , 2 , 20 , -100 , 2 , 20 ,
CREATE lefying1 -100 , -2 , 0 , -100 , 2 , 0 ,
                -100 , 2 , 20 , -100 , -2 , 20 ,
CREATE rigying1  -20 , -2 , 0 , -20 , 2 , 0 ,
                -20 , 2 , 20 , -20 , -2 , 20 ,

CREATE topying2 20 , -2 , 20 , 100 , -2 , 20 ,
                100 , 2 , 20 , 20 , 2 , 20 ,
CREATE botying2 20 , -2 , 0 , 100 , -2 , 0 ,
                100 , 2 , 0 , 20 , 2 , 0 ,
CREATE forying2 20 , -2 , 0 , 100 , -2 , 0 ,
                100 , -2 , 20 , 20 , -2 , 20 ,
CREATE bacying2 20 , 2 , 0 , 100 , 2 , 0 ,
                100 , 2 , 20 , 20 , 2 , 20 ,
CREATE lefying2 20 , -2 , 0 , 20 , 2 , 0 ,
                20 , 2 , 20 , 20 , -2 , 20 ,
CREATE rigying2  100 , -2 , 0 , 100 , 2 , 0 ,
                100 , 2 , 20 , 100 , -2 , 20 ,


: init  ginit
        RGBmode
(       1 zbuffer )
        gconfig
        $4040 cpack
        clear
(       zclear )
        ;

: yingyang
        pushmatrix
        0.0 0.0 40 FLOAT translate
        $FFFFFF cpack
        500 500 120 0 1800 arcfi
        0 cpack
        500 500 120 1800 0 arcfi
        $FFFFFF cpack
        440 500 60 circfi
        $0 cpack
        560 500 60 circfi
        $FFFFFF cpack
        560 500 20 circfi
        0 cpack
        440 500 20 circfi
        popmatrix
        ;


CREATE MESH1 0 , 0 , 0 ,
CREATE MESH2 0 , 0 , 0 ,

PI 36 FLOAT F/ CONSTANT THETA

VARIABLE HEIGHT1
VARIABLE HEIGHT2
VARIABLE R1
VARIABLE R2

: FLAT  bgntmesh
        HEIGHT1 @ DUP MESH1 8 + ! MESH2 8 + !
        0.0 ( init angle ) 72 ( segments in a cirle )
        FOR
                DUP FSIN OVER FCOS
                DUP R1 @ F* INT 500 + MESH1 !
                OVER R1 @ F* INT 500 + MESH1 CELL+ !
                MESH1 v3i
                R2 @ F* INT 500 + MESH2 !
                R2 @ F* INT 500 + MESH2 CELL+ !
                MESH2 v3i
                THETA F+
        NEXT    DROP
        endtmesh
        ;

: STEP  bgntmesh
        HEIGHT1 @ MESH1 8 + ! 
        HEIGHT2 @ MESH2 8 + !
        0.0 ( init angle ) 72 ( segments in a cirle )
        FOR     
                DUP FSIN OVER FCOS
                R2 @ F* INT 500 + DUP MESH1 ! MESH2 !
                R2 @ F* INT 500 + DUP
                MESH1 CELL+ ! MESH2 CELL+ !
                MESH1 v3i
                MESH2 v3i
                THETA F+
        NEXT    DROP
        endtmesh
        ;


: circles
        130 HEIGHT1 ! 120 HEIGHT2 !
        480
        14 FOR  DUP FLOAT R1 !
                10 - DUP FLOAT R2 !
                $C00000 cpack
                FLAT
                $000000 cpack
                STEP
                -10 HEIGHT1 +!
                -10 HEIGHT2 +!
        NEXT    DROP
        ;

: steps
        40 HEIGHT1 ! 30 HEIGHT2 !
        120
        3 FOR   DUP FLOAT R1 !
                10 + DUP FLOAT R2 !
                $808080 cpack
                FLAT
                $000000 cpack
                STEP
                -10 HEIGHT1 +!
                -10 HEIGHT2 +!
        NEXT    DROP
        ;

        
: yang  $E0E0E0 cpack
        4 topyang polfi
        $C0C0C0 cpack
        4 foryang polfi
        $C0C0C0 cpack
        4 bacyang polfi
        $A0A0A0 cpack
        4 lefyang polfi
        $A0A0A0 cpack
        4 rigyang polfi
        ( $E0E0E0 cpack )
        ( 4 botyang polfi )
        ;

: ying  $E0E0E0 cpack
        4 topying1 polfi
        $C0C0C0 cpack
        4 forying1 polfi
        $C0C0C0 cpack
        4 bacying1 polfi
        $A0A0A0 cpack
        4 lefying1 polfi
        $A0A0A0 cpack
        4 rigying1 polfi
        ( $E0E0E0 cpack )
        ( 4 botying1 polfi )
        $E0E0E0 cpack
        4 topying2 polfi
        $C0C0C0 cpack
        4 forying2 polfi
        $C0C0C0 cpack
        4 bacying2 polfi
        $A0A0A0 cpack
        4 lefying2 polfi
        $A0A0A0 cpack
        4 rigying2 polfi
        ( $E0E0E0 cpack )
        ( 4 botying2 polfi )
        ;

: octagrams
        pushmatrix
        500 FLOAT DUP 120 FLOAT translate

        pushmatrix
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -20 FLOAT DUP translate
        yang
        0.0 -20 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        450 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -20 FLOAT DUP translate
        yang
        0.0 -20 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        900 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -20 FLOAT DUP translate
        ying
        0.0 -20 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        1350 122 rotate
        0.0 460 FLOAT 0.0 translate
        yang
        0.0 -20 FLOAT DUP translate
        ying
        0.0 -20 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        1800 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -20 FLOAT DUP translate
        ying
        0.0 -20 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        2250 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -20 FLOAT DUP translate
        ying
        0.0 -20 FLOAT DUP translate
        yang
        popmatrix

        pushmatrix
        2700 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -20 FLOAT DUP translate
        yang
        0.0 -20 FLOAT DUP translate
        ying
        popmatrix

        pushmatrix
        3150 122 rotate
        0.0 460 FLOAT 0.0 translate
        ying
        0.0 -20 FLOAT DUP translate
        yang
        0.0 -20 FLOAT DUP translate
        yang
        popmatrix

        popmatrix
        ;

: test6 ( angle axis -- )
        init
        0.0 1280 FLOAT 
        0.0 1000 FLOAT -1000 FLOAT 1000 FLOAT ortho
        rotate 
        ( 900 1.0 10.0 2000 FLOAT perspective )
        ( >R 500 FLOAT 0.0 OVER 500 FLOAT DUP 0.0 R> lookat )
        circles
        steps
        yingyang
        octagrams
        10 sleep
        gexit
        ;
        
        
        
<110 weaver2 /work/ls> ls -l *.f
-rw-r--r--   1 ting     user        1265 Sep 11 23:02 circuit.f
-rw-r--r--   1 ting     user         166 Aug 22 01:22 device.f
-rw-r--r--   1 ting     user        3531 Sep 12 21:21 flower.f
-rw-r--r--   1 ting     user        2015 Sep 12 22:04 flower2.f
-rw-r--r--   1 ting     user         238 Sep  1 20:42 hi.f
-rw-r--r--   1 ting     user        2176 Sep 11 23:03 man.f
-rw-r--r--   1 ting     user         639 Aug 21 01:22 mandelbrot.f
-rw-r--r--   1 ting     user         107 Aug 20 22:52 plot.f
-rw-r--r--   1 ting     user        3966 Sep 11 23:02 trees.f
-rw-r--r--   1 ting     user         263 Sep 11 09:51 walnut.f
-rw-r--r--   1 ting     user         526 Sep  4 21:29 win.f
-rw-r--r--   1 ting     user        1570 Aug 23 22:10 yin.f
-rw-r--r--   1 ting     user        2014 Aug 25 18:16 yin1.f
-rw-r--r--   1 ting     user        4870 Aug 26 22:30 yin2.f
-rw-r--r--   1 ting     user        6261 Sep 11 23:03 yin3.f
-rw-r--r--   1 ting     user        5036 Aug 30 21:32 yin4.f
<111 weaver2 /work/ls> 