cat eforth.s
cat: cannot open eforth.s
<108 weaver2 /work/ls> cat eForth.s

 #      Debugged through OVERT, where a segmentation fault
 #      occurred because o storing LAST into FORTH. 7/23/93 cht
 #      Change vocabulary data field to .data segment.
 #      Use scanf to get a line in QUERY.  scanf does not return
 #      character count.  sad.
 #      Try read() to get characters one at a time.
 #      7/30/93 interpreter works.  does not compile due to segmentation.
 #      8/3/93  Change to indirect threaded code.  separate code
 #              from colon definitions.  compiler works.
 #      8/6/93  Test read file hi.f.
 #      8/8/93  Test INCLUDE.  Works ine on hi.f.

        .verstamp       2 40
        .align  4
        .set    macro
        .set    noreorder

        COMPO=0X40
        IMEDD=0X80
        MASKK=0X1F7F7F7F
        CELLL=4
        BASEE=10
        VOCSS=8
        BKSPP=8
        LF=10
        CRR=13          # can't input a CR
        ERR=27
        TIC=39

  #     ax=$8
  #     bx=$9
  #     cx=$10
  #     dx=$11
  #     sp=$16
  #     rp=$17
  #     ip=$18
  #     wp=$19
 #      wp=$31


        .text
        .globl  eForth
        .ent    eForth

eForth: sw      $16, SAVSP
        sw      $31, SAVLINK
        la      $16, SPP-12
        sw      $19, 8($16)
        sw      $17, 4($16)
        sw      $18, 0($16)
        nop

        la      $18, COLD1

 # Test High Level Words
 #      la      $18, QUERY+8
 #      la      $18, IOTST+8

 #      addiu   $16, -8         # test 'find'
 #      la      $8, FVOC
 #      sw      $8, 0($16)
 #      la      $8, p6
 #      sw      $8, 4($16)
 #      la      $18, FIND+8

        la      $17, RPP-4
        sw      $18, RPP-4

 # Indirect threaded inner interpreter.

$next:  
 #      jal     DBG
 #      nop

        lw      $8, 0($18)      # get next word in list
        addiu   $18, $18, 4     # increment ip
        lw      $9, 0($8)       # get address in code field
        move    $19, $8
        j       $9              # indirect jump to next word
        addiu   $19, $19, 4     # set up wp to pfa
        
 # Call DBG in $next or in dolst to sinlge step Forth code.

DBG:    sw      $16, ULAST      # display sp, ip, wp
        sw      $17, ULAST+4    #         s0, s1, s2
        sw      $18, ULAST+8    #         rp, r0, r1
        sw      $31, ULAST+12   # call from either $next or dolst
        sw      $19, ULAST+16
        la      $4, msg9
        move    $5, $16
        move    $6, $18
        lw      $7, 0($18)
        jal     printf
        nop
        la      $4, msg10
        lw      $5, 0($16)
        lw      $6, 4($16)
        lw      $7, 8($16)
        jal     printf
        nop
        la      $4, msg8
        move    $5, $17
        lw      $6, 0($17)
        lw      $7, 4($17)
        jal     printf
        nop
        jal     getchar
        nop
        move    $4, $2
        jal     putchar
        nop
        lw      $19, ULAST+16
        lw      $31, ULAST+12
        lw      $16, ULAST
        lw      $17, ULAST+4
        lw      $18, ULAST+8
        j       $31
        nop

BYE:    .word   BYE+4
        lw      $31, SAVLINK    
        la      $16, SPP-12
        lw      $19, 8($16)
        lw      $17, 4($16)
        lw      $18, 0($16)
        lw      $16, SAVSP
        j       $31
        nop

QRX:    .word   QRX+4
        li      $4, 0
        la      $5, INBUF
        li      $6, 1
        jal     read
        nop
        addiu   $16, $16, -4
        beq     $2, $0, $next
        sw      $0, 0($16)
        la      $8, INBUF
        li      $9, -1
        lbu     $8, 0($8)
        nop
        sw      $8, 0($16)
        addiu   $16, $16, -4
        j       $next
        sw      $9, 0($16)
        
TXSTO:  .word   TXSTO+4
        lw      $4, 0($16)
        addiu   $16, $16, 4
        jal     putchar
        nop
        j       $next
        nop

 #IOTST:        .word   dolst
 #IOTS1:        .word   QRX, QBRAN, IOTS2
 #IOTS2:        .word   TXSTO, BRAN, IOTS1

STOIO:  .word   STOIO+4
        j       $next
        nop

DOLIT:  .word   DOLIT+4
        lw      $8, 0($18)
        addiu   $16, $16, -4
        addiu   $18, $18, 4
        j       $next
        sw      $8, 0($16)

 # Colon word interpreter to lead the colon words

dolst:
DOLST:  addiu   $17, $17, -4    # push ip
        sw      $18, 0($17)     # onto rp
        move    $18, $19        # move wp into ip
        nop

 #      jal     DBG
 #      nop
 
        j       $next           # execute list in pf
        nop

EXIT:   .word   EXIT+4
        lw      $18, 0($17)     # get ip from rp
        j       $next           # return to calling list
        addiu   $17, $17, 4     # pop rp
        
EXECU:  .word   EXECU+4
        lw      $8, 0($16)      # get cfa from sp
        addiu   $16, $16, 4     # pop sp
        lw      $9, 0($8)       # get address in code field
        move    $19, $8
        j       $9              # indirect jump to next word
        addiu   $19, $19, 4     # set up wp to pfa

DONXT:  .word   DONXT+4
        lw      $8, 0($17)
        nop
        beq     $8, $0, NEXT1
        nop
        addiu   $8, $8, -1
        sw      $8, 0($17)
        lw      $18, 0($18)
        j       $next
        nop
NEXT1:  addiu   $18, $18, 4
        j       $next
        addiu   $17, $17, 4

        
QBRAN:  .word   QBRAN+4
        lw      $8, 0($16)
        addiu   $16, $16, 4
        beq     $8, $0, BRAN1
        nop
        addiu   $18, $18, 4
        j       $next
        nop
BRAN1:  lw      $18, 0($18)
        j       $next
        nop

BRAN:   .word   BRAN+4
        lw      $18, 0($18)
        j       $next
        nop

STORE:  .word   STORE+4
        lw      $9, 0($16)
        lw      $8, 4($16)
        addiu   $16, $16, 8
        j       $next
        sw      $8, 0($9)

AT:     .word   AT+4
        lw      $9, 0($16)
        nop
        lw      $8, 0($9)
        j       $next
        sw      $8, 0($16)
        
CSTOR:  .word   CSTOR+4
        lw      $9, 0($16)
        lw      $8, 4($16)
        addiu   $16, $16, 8
        j       $next
        sb      $8, 0($9)

CAT:    .word   CAT+4
        lw      $9, 0($16)
        nop
        lbu     $8, 0($9)
        j       $next
        sw      $8, 0($16)
        
WSTOR:  .word   WSTOR+4
        lw      $9, 0($16)
        lw      $8, 4($16)
        addiu   $16, $16, 8
        j       $next
        sh      $8, 0($9)

WAT:    .word   WAT+4
        lw      $9, 0($16)
        nop
        lhu     $8, 0($9)
        j       $next
        sw      $8, 0($16)
        
RPAT:   .word   RPAT+4
        addiu   $16, $16, -4
        j       $next
        sw      $17, 0($16)

RPSTO:  .word   RPSTO+4
        lw      $8, 0($16)
        addiu   $16, $16, 4
        j       $next
        or      $17, $8, $0
        
RFROM:  .word   RFROM+4
        lw      $8, 0($17)
        addiu   $16, $16, -4
        sw      $8, 0($16)
        j       $next
        addiu   $17, $17, 4

RAT:    .word   RAT+4
        lw      $8, 0($17)
        addiu   $16, $16, -4
        j       $next
        sw      $8, 0($16)

TOR:    .word   TOR+4
        lw      $8, 0($16)
        addiu   $17, $17, -4
        sw      $8, 0($17)
        j       $next
        addiu   $16, $16, 4

SPAT:   .word   SPAT+4
        or      $8, $16, $0
        addiu   $16, $16, -4
        j       $next
        sw      $8, 0($16)

SPSTO:  .word   SPSTO+4
        j       $next
        lw      $16, 0($16)
        
DROP:   .word   DROP+4
        j       $next
        addiu   $16, $16, 4

DUPP:   .word   DUPP+4
        lw      $8, 0($16)
        addiu   $16, $16, -4
        j       $next
        sw      $8, 0($16)

SWAP:   .word   SWAP+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        sw      $8, 4($16)
        j       $next
        sw      $9, 0($16)

OVER:   .word   OVER+4
        lw      $8, 4($16)
        addiu   $16, $16, -4
        j       $next
        sw      $8, 0($16)

ZLESS:  .word   ZLESS+4
        lw      $8, 0($16)
        li      $9, -1
        blt     $8, $0, $next
        sw      $9, 0($16)
        j       $next
        sw      $0, 0($16)
        
ANDD:   .word   ANDD+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        and     $8, $8, $9
        j       $next
        sw      $8, 0($16)

ORR:    .word   ORR+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        or      $8, $8, $9
        j       $next
        sw      $8, 0($16)

XORR:   .word   XORR+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        xor     $8, $8, $9
        j       $next
        sw      $8, 0($16)

UPLUS:  .word   UPLUS+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        nop
        addu    $8, $8, $9
        sltu    $10, $8, $9
        sw      $8, 4($16)
        j       $next
        sw      $10, 0($16)

 ######  Following words are optimized for MIPS uP #####

QDUP:   .word   QDUP+4
        lw      $8, 0($16)
        nop
        beq     $8, $0, $next
        nop
        addiu   $16, $16, -4
        j       $next
        sw      $8, 0($16)

ROT:    .word   ROT+4
        lw $8, 0($16)
        lw $9, 4($16)
        lw $10, 8($16)
        sw $8, 4($16)
        sw $9, 8($16)
        j       $next
        sw $10, 0($16)

DDROP:  .word   DDROP+4
        j       $next
        addiu $16, $16, 8

DDUP:   .word   DDUP+4
        lw $8, 0($16)
        lw $9, 4($16)
        addiu $16, $16, -8
        sw $8, 0($16)
        j $next
        sw $9, 4($16)

PLUS:   .word   PLUS+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        addu    $8, $8, $9
        j       $next
        sw      $8, 0($16)


DPLUS:  .word   DPLUS+4
        lw      $8, 12($16)
        lw      $9, 8($16)
        nop
        addu    $8, $8, $9
        sltu    $10, $8, $9
        sw      $8, 12($16)
        lw      $8, 4($16)
        lw      $9, 0($16)
        addiu   $16, $16, 8
        addu    $8, $8, $9
        addu    $8, $8, $10
        j       $next
        sw      $8, 0($16)


INVER:  .word   INVER+4
        lw      $8, 0($16)
        li      $9, -1
        xor     $8, $8, $9
        j       $next
        sw      $8, 0($16)


NEGAT:  .word   NEGAT+4
        lw      $8, 0($16)
        nop
        subu    $8, $0, $8
        j       $next
        sw      $8, 0($16)

SUBB:   .word   SUBB+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        subu    $8, $9, $8
        j       $next
        sw      $8, 0($16)

ABSS:   .word   ABSS+4
        lw      $8, 0($16)
        nop
        bge     $8, $0, $next
        subu    $8, $0, $8
        j       $next
        sw      $8, 0($16)


EQUAL:  .word   EQUAL+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        beq     $8, $9, EQUA1
        li      $8, -1
        li      $8, 0
EQUA1:  j       $next
        sw      $8, 0($16)


ULESS:  .word   ULESS+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        bltu    $9, $8, ULES1
        li      $8, -1
        li      $8, 0
ULES1:  j       $next
        sw      $8, 0($16)

  # signed compare of top two

LESS:   .word   LESS+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        blt     $9, $8, LESS1
        li      $8, -1
        li      $8, 0
LESS1:  j       $next
        sw      $8, 0($16)

  # return greater of top two

MAX:    .word   MAX+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        bgt     $9, $8, $next
        nop
        j       $next
        sw      $8, 0($16)

  # return smaller of top two

MIN:    .word   MIN+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        addiu   $16, $16, 4
        blt     $9, $8, $next
        nop
        j       $next
        sw      $8, 0($16)


  # unsigned divide of a double by a single, return mod and quotient
  # upper 32 bits are ignored.  In effect a 32 bits divide.

UMMOD:  .word   UMMOD+4
        lw      $8, 0($16)
        lw      $9, 8($16)
        addiu   $16, $16, 4
        divu    $9, $8
        mfhi    $8
        mflo    $9
        sw      $8, 4($16)
        j       $next
        sw      $9, 0($16)


  # signed floored divide of double by single, return mod and quotient
  # upper 32 bits are ignored.  In effect a 32 bits divide.

MSMOD:  .word   MSMOD+4
        lw      $8, 0($16)
        lw      $9, 8($16)
        addiu   $16, $16, 4
        div     $9, $8
        mfhi    $8
        mflo    $9
        sw      $8, 4($16)
        j       $next
        sw      $9, 0($16)

  # signed divide, return mod and quotient

SLMOD:  .word   SLMOD+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        nop
        div     $9, $8
        mfhi    $8
        mflo    $9
        sw      $8, 4($16)
        j       $next
        sw      $9, 0($16)

  # signed divide, return mod only

MODD:   .word   MODD+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        nop
        div     $9, $8
        mfhi    $8
        addiu   $16, $16, 4
        j       $next
        sw      $8, 0($16)

  # signed divide, return quotient only

SLASH:  .word   SLASH+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        nop
        div     $9, $8
        mflo    $9
        addiu   $16, $16, 4
        j       $next
        sw      $9, 0($16)

  # unsigned multiply, return double product

UMSTA:  .word   UMSTA+4
        lw $8, 0($16)
        lw $9, 4($16)
        nop
        multu $8, $9
        mflo $8
        mfhi $9
        sw      $8, 4($16)
        j $next
        sw      $9, 0($16)

  # signed multiply, return single product

STAR:   .word   STAR+4
        lw $8, 0($16)
        lw $9, 4($16)
        nop
        mult $8, $9
        mflo $8
        sw      $8, 4($16)
        j $next
        addiu $16, $16, 4

  # signed multiply, return double product

MSTAR:  .word   MSTAR+4
        lw $8, 0($16)
        lw $9, 4($16)
        nop
        mult $8, $9
        mflo $8
        mfhi $9
        sw      $8, 4($16)
        j $next
        sw      $9, 0($16)

CELLP:  .word   CELLP+4
        lw      $8, 0($16)
        nop
        addiu   $8, CELLL
        j       $next
        sw      $8, 0($16)

CELLM:  .word   CELLM+4
        lw      $8, 0($16)
        nop
        addiu   $8, -(CELLL)
        j       $next
        sw      $8, 0($16)


CELLS:  .word   CELLS+4
        lw      $8, 0($16)
        li      $9, CELLL
        mult    $8, $9
        mflo    $8
        j       $next
        sw      $8, 0($16)

ALGND:  .word   ALGND+4
        lw      $8, 0($16)
        li      $9, (CELLL-1)
        and     $10, $9, $8
        beq     $10, $0, $next
        xor     $8, $8, $10
        addiu   $8, CELLL
        j       $next
        sw      $8, 0($16)

PICK:   .word   PICK+4
        lw      $8, 0($16)
        li      $9, CELLL
        addiu   $8, 1
        multu   $8, $9
        mflo    $9
        addu    $9, $9, $16
        lw      $8, 0($9)
        j       $next
        sw      $8, 0($16)

CMOVE:  .word   CMOVE+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        lw      $10, 8($16)
        addiu   $16, 12
CMOV1:  beq     $8, $0, $next
        lb      $11, 0($10)
        addiu   $10, 1
        sb      $11, 0($9)
        addiu   $8, -1
        j       CMOV1
        addiu   $9, 1

MOVEE:  .word   MOVEE+4
        lw      $8, 0($16)
        lw      $9, 4($16)
        lw      $10, 8($16)
        addiu   $16, 12
MOV1:   beq     $8, $0, $next
        lw      $11, 0($10)
        addiu   $10, 4
        sw      $18, 0($9)
        addiu   $8, -1
        j       CMOV1
        addiu   $9, 4


 ##### open and read source file #####

 # OPEN ( file-buffer file-name-ptr -- bytes-read, 0 if error )

OPEN:   .word   OPEN+4
        lw      $4, 0($16)
        move    $5, $0
        jal     open
        nop
        bne     $2, -1, OPEN1
        la      $4, msg5
        jal     printf
        nop
        sw      $0, 4($16)
        j       $next
        addiu   $16, $16, 4
OPEN1:  move    $4, $2
        lw      $5, 4($16)
        li      $6, -1
        jal     read
        nop
        addiu   $16, $16, 4
        j       $next
        sw      $2, 0($16)

 ######### high level words #############

        .data   # put all high level words in data space


 ######### user variables ###############

DOVAR:  
        .word   dolst
.word   RFROM, EXIT

UP:
        .word   dolst
.word   DOVAR, UPP

DOUSE:
        .word   dolst
.word   RFROM, AT, UP, AT, PLUS, EXIT
        
SZERO:  .word   dolst
.word   DOUSE, 16

RZERO:  .word   dolst
.word   DOUSE, 20

TQKEY:  .word   dolst
.word   DOUSE, 24

TEMIT:  .word   dolst
.word   DOUSE, 28

TEXPE:  .word   dolst
.word   DOUSE, 32

TTAP:   .word   dolst
.word   DOUSE, 36

TECHO:  .word   dolst
.word   DOUSE, 40

TPROM:  .word   dolst
.word   DOUSE, 44

BASE:   .word   dolst
.word   DOUSE, 48

TEMP:   .word   dolst
.word   DOUSE, 52

SPAN:   .word   dolst
.word   DOUSE, 56

INN:    .word   dolst
.word   DOUSE, 60

NTIB:   .word   dolst
.word   DOUSE, 64

CSP:    .word   dolst
.word   DOUSE, 72

TEVAL:  .word   dolst
.word   DOUSE, 76

TNUMB:  .word   dolst
.word   DOUSE, 80

HLD:    .word   dolst
.word   DOUSE, 84

HANDL:  .word   dolst
.word   DOUSE, 88

CNTXT:  .word   dolst
.word   DOUSE, 92

CRRNT:  .word   dolst
.word   DOUSE, 124

CP:     .word   dolst
.word   DOUSE, 136

NP:     .word   dolst
.word   DOUSE, 140

LAST:   .word   dolst
.word   DOUSE, 144


 ##### vocabulary words #####

DOVOC:  .word   dolst
.word   RFROM, AT, CNTXT, STORE, EXIT

FORTH:  .word   dolst
.word   DOVOC
.word   FVOC
.word   0


  ######  MISCELLANEOUS ######


  # return true if u is within the range of ul and uh
WITHI:  .word   dolst
.word OVER,SUBB,TOR
.word SUBB,RFROM,ULESS,EXIT

DNEGA:  .word   dolst
.word INVER,TOR,INVER
.word DOLIT,1,UPLUS
.word RFROM,PLUS,EXIT

  # return mod and quotient of n1 * n2 / n3
SSMOD:  .word   dolst
.word TOR,MSTAR,RFROM,MSMOD,EXIT

  # return quotient of n1 * n2 / n3
STASL:  .word   dolst
.word SSMOD,SWAP,DROP,EXIT

BLANK:  .word   dolst
.word DOLIT,32,EXIT

TCHAR:  .word   dolst
.word DOLIT,0x7F,ANDD,DUPP
.word BLANK,DOLIT,127,WITHI,INVER
.word QBRAN,TCHA1
.word DROP,DOLIT,95
TCHA1:
.word EXIT


DEPTH:  .word   dolst

.word SPAT,SZERO,AT,SWAP,SUBB
.word DOLIT,CELLL,SLASH,EXIT

PSTOR:  .word   dolst

.word SWAP,OVER,AT,PLUS
.word SWAP,STORE,EXIT

DSTOR:  .word   dolst
.word SWAP,OVER,STORE
.word CELLP,STORE,EXIT

DAT:    .word   dolst
.word DUPP, CELLP, AT
.word SWAP, AT, EXIT

COUNT:  .word   dolst
.word DUPP,DOLIT,1,PLUS
.word SWAP,CAT,EXIT

HERE:   .word   dolst
.word CP,AT,EXIT

PAD:    .word   dolst
.word HERE,DOLIT,80,PLUS,EXIT

TIB:    .word   dolst
.word NTIB,CELLP,AT,EXIT

ATEXE:  .word   dolst
.word AT,QDUP
.word QBRAN,EXE1
.word EXECU
EXE1:
.word EXIT


 ##### string words #####


FILL:   .word   dolst
.word SWAP,TOR,SWAP
.word BRAN,FILL2
FILL1:
.word DDUP,CSTOR,DOLIT,1,PLUS
FILL2:
.word DONXT,FILL1
.word DDROP,EXIT

DTRAI:  .word   dolst
.word TOR
.word BRAN,DTRA2
DTRA1:
.word BLANK,OVER,RAT,PLUS,CAT,LESS
.word QBRAN,DTRA2
.word RFROM,DOLIT,1,PLUS,EXIT
DTRA2:
.word DONXT,DTRA1
.word DOLIT,0,EXIT

PACKS:  .word   dolst
.word ALGND,DUPP,TOR
.word OVER,DUPP,DOLIT,0
.word DOLIT,CELLL,UMMOD,DROP
.word SUBB,OVER,PLUS
.word DOLIT,0,SWAP,STORE
.word DDUP,CSTOR,DOLIT,1,PLUS
.word SWAP,CMOVE,RFROM,EXIT


 ##### number conversions #####


DIGIT:  .word   dolst
.word DOLIT,9,OVER,LESS
.word DOLIT,7,ANDD,PLUS
.word DOLIT,48,PLUS,EXIT

EXTRC:  .word   dolst
.word DOLIT,0,SWAP,UMMOD
.word SWAP,DIGIT,EXIT

BDIGS:  .word   dolst
.word PAD,HLD,STORE,EXIT

HOLD:   .word   dolst
.word HLD,AT,DOLIT,1,SUBB
.word DUPP,HLD,STORE,CSTOR,EXIT

DIG:    .word   dolst
.word BASE,AT,EXTRC,HOLD,EXIT

DIGS:   .word   dolst
DIGS1:
.word DIG,DUPP
.word QBRAN,DIGS2
.word BRAN,DIGS1
DIGS2:
.word EXIT

SIGN:   .word   dolst
.word ZLESS
.word QBRAN,SIGN1
.word DOLIT,45,HOLD
SIGN1:
.word EXIT

EDIGS:  .word   dolst
.word DROP,HLD,AT
.word PAD,OVER,SUBB,EXIT

STRR:   .word   dolst
.word DUPP,TOR,ABSS
.word BDIGS,DIGS,RFROM
.word SIGN,EDIGS,EXIT

HEX:    .word   dolst
.word DOLIT,16,BASE,STORE,EXIT

DECIM:  .word   dolst
.word DOLIT,10,BASE,STORE,EXIT

DIGTQ:  .word   dolst
.word TOR,DOLIT,48,SUBB
.word DOLIT,9,OVER,LESS
.word QBRAN,DGTQ1
.word DOLIT,7,SUBB
.word DUPP,DOLIT,10,LESS,ORR
DGTQ1:
.word DUPP,RFROM,ULESS,EXIT

NUMBQ:  .word   dolst
.word BASE,AT,TOR,DOLIT,0,OVER,COUNT
.word OVER,CAT,DOLIT,36,EQUAL
.word QBRAN,NUMQ1
.word HEX,SWAP,DOLIT,1,PLUS
.word SWAP,DOLIT,1,SUBB
NUMQ1:
.word OVER,CAT,DOLIT,45,EQUAL,TOR
.word SWAP,RAT,SUBB,SWAP,RAT,PLUS,QDUP
.word QBRAN,NUMQ6
.word DOLIT,1,SUBB,TOR
NUMQ2:
.word DUPP,TOR,CAT,BASE,AT,DIGTQ
.word QBRAN,NUMQ4
.word SWAP,BASE,AT,STAR,PLUS,RFROM
.word DOLIT,1,PLUS
.word DONXT,NUMQ2
.word RAT,SWAP,DROP
.word QBRAN,NUMQ3
.word NEGAT
NUMQ3:
.word SWAP
.word BRAN,NUMQ5
NUMQ4:
.word RFROM,RFROM,DDROP,DDROP,DOLIT,0
NUMQ5:
.word DUPP
NUMQ6:
.word RFROM,DDROP
.word RFROM,BASE,STORE,EXIT


 ##### input output words #####


QKEY:   .word   dolst
.word   TQKEY, ATEXE, EXIT

KEY:    .word   dolst
KEY1:
.word   QKEY, QBRAN, KEY1, EXIT

EMIT:   .word   dolst
.word   TEMIT, ATEXE, EXIT

NUFQ:   .word   dolst
.word   QKEY, DUPP, QBRAN, NUFQ1
.word   DDROP, KEY, DOLIT, LF, EQUAL
NUFQ1:
.word   EXIT

PACE:   .word   dolst
.word   DOLIT, 11, EMIT, EXIT

SPACE:  .word   dolst
.word   BLANK, EMIT, EXIT

SPACS:  .word   dolst
.word   DOLIT, 0 MAX, TOR
.word   BRAN, CHAR2
CHAR1:
.word   SPACE
CHAR2:
.word   DONXT, CHAR1, EXIT

TYPEE:  .word   dolst
.word   TOR, BRAN, TYPE2
TYPE1:
.word   DUPP, CAT, EMIT, DOLIT, 1, PLUS
TYPE2:
.word   DONXT, TYPE1, DROP, EXIT

CR:     .word   dolst
 #      .word   DOLIT, CRR, EMIT
.word   DOLIT, LF, EMIT, EXIT


DOSTR:  .word   dolst
.word RFROM,RAT,RFROM,COUNT,PLUS
.word ALGND,TOR,SWAP,TOR,EXIT

STRQP:  .word   dolst
.word DOSTR,EXIT

DOTQP:  .word   dolst
.word DOSTR,COUNT,TYPEE,EXIT

DOTR:   .word   dolst
.word TOR,STRR,RFROM,OVER,SUBB
.word SPACS,TYPEE,EXIT

UDOTR:  .word   dolst
.word TOR,BDIGS,DIGS,EDIGS
.word RFROM,OVER,SUBB
.word SPACS,TYPEE,EXIT

UDOT:   .word   dolst
.word BDIGS,DIGS,EDIGS
.word SPACE,TYPEE,EXIT

DOT:    .word   dolst
.word BASE,AT,DOLIT,10,XORR
.word QBRAN,DOT1
.word UDOT,EXIT
DOT1:
.word STRR,SPACE,TYPEE,EXIT

QUEST:  .word   dolst
.word AT,DOT,EXIT


 ##### text interpreter #####


PARS:   .word   dolst
.word TEMP,STORE,OVER,TOR,DUPP
.word QBRAN,PARS8
.word DOLIT,1,SUBB,TEMP,AT,BLANK,EQUAL
.word QBRAN,PARS3
.word TOR
PARS1:
.word BLANK,OVER,CAT
.word SUBB,ZLESS,INVER
.word QBRAN,PARS2
.word DOLIT,1,PLUS
.word DONXT,PARS1
.word RFROM,DROP,DOLIT,0,DUPP,EXIT
PARS2:
.word RFROM
PARS3:
.word OVER,SWAP
.word TOR
PARS4:
.word TEMP,AT,OVER,CAT,SUBB
.word TEMP,AT,BLANK,EQUAL
.word QBRAN,PARS5
.word ZLESS
PARS5:
.word QBRAN,PARS6
.word DOLIT,1,PLUS
.word DONXT,PARS4
.word DUPP,TOR
.word BRAN,PARS7
PARS6:
.word RFROM,DROP,DUPP
.word DOLIT,1,PLUS,TOR
PARS7:
.word OVER,SUBB
.word RFROM,RFROM,SUBB,EXIT
PARS8:
.word OVER,RFROM,SUBB,EXIT

PARSE:  .word   dolst
.word TOR,TIB,INN,AT,PLUS
.word NTIB,AT,INN,AT,SUBB
.word RFROM,PARS,INN,PSTOR,EXIT

DOTPR:  .word   dolst
.word DOLIT,41,PARSE,TYPEE,EXIT

PAREN:  .word   dolst
.word DOLIT,41,PARSE,DDROP,EXIT

BKSLA:  .word   dolst
.word NTIB,AT,INN,STORE,EXIT

CHAR:   .word   dolst
.word BLANK, PARSE, DROP, CAT, EXIT

TOKEN:  .word   dolst
.word BLANK,PARSE,DOLIT,31,MIN
.word NP,AT,OVER,SUBB,CELLM
.word PACKS,EXIT

WORDD:  .word   dolst
.word PARSE,HERE,PACKS,EXIT

NAMET:  .word   dolst
.word CELLM
.word CELLM,AT,EXIT

SAMEQ:  .word   dolst
.word TOR
.word BRAN,SAME2
SAME1:
.word OVER,RAT,CELLS,PLUS,AT
.word OVER,RAT,CELLS,PLUS,AT
.word SUBB,QDUP
.word QBRAN,SAME2
.word RFROM,DROP,EXIT
SAME2:
.word DONXT,SAME1
.word DOLIT,0,EXIT

FIND:   .word   dolst
.word SWAP,DUPP,CAT
.word DOLIT,CELLL,SLASH,TEMP,STORE
.word DUPP,AT,TOR,CELLP,SWAP
FIND1:
.word AT,DUPP
.word QBRAN,FIND6
.word DUPP,AT,DOLIT,MASKK,ANDD,RAT,XORR
.word QBRAN,FIND2
.word CELLM
.word BRAN,FIND1
FIND2:
.word CELLP,TEMP,AT,SAMEQ
FIND3:
.word BRAN,FIND4
FIND6:
.word RFROM,DROP
.word SWAP,CELLM,SWAP,EXIT
FIND4:
.word QBRAN,FIND5
.word CELLM,CELLM
.word BRAN,FIND1
FIND5:
.word RFROM,DROP,SWAP,DROP
.word CELLM
.word DUPP,NAMET,SWAP,EXIT

NAMEQ:  .word   dolst
.word CNTXT,DUPP,DAT,XORR
.word QBRAN,NAMQ1
.word CELLM
NAMQ1:
.word TOR
NAMQ2:
.word RFROM,CELLP,DUPP,TOR
.word AT,QDUP
.word QBRAN,NAMQ3
.word FIND,QDUP
.word QBRAN,NAMQ2
.word RFROM,DROP,EXIT
NAMQ3:
.word RFROM,DROP
.word DOLIT,0,EXIT

BKSP:   .word   dolst
.word TOR,OVER,RFROM,SWAP,OVER,XORR
.word QBRAN,BACK1
.word DOLIT,BKSPP,TECHO,ATEXE,DOLIT,1,SUBB
.word BLANK,TECHO,ATEXE
.word DOLIT,BKSPP,TECHO,ATEXE
BACK1:
.word EXIT

TAP:    .word   dolst
.word DUPP,TECHO,ATEXE
.word OVER,CSTOR,DOLIT,1,PLUS,EXIT

KTAP:   .word   dolst
.word DUPP,DOLIT,LF,XORR
.word QBRAN,KTAP2
.word DOLIT,BKSPP,XORR
.word QBRAN,KTAP1
.word BLANK,TAP,EXIT
KTAP1:
.word BKSP,EXIT
KTAP2:
.word DROP,SWAP,DROP,DUPP,EXIT

ACCEP:  .word   dolst
.word OVER,PLUS,OVER
ACCP1:
.word DDUP,XORR
.word QBRAN,ACCP4
.word KEY,DUPP
.word BLANK,DOLIT,127,WITHI
.word QBRAN,ACCP2
.word TAP
.word BRAN,ACCP3
ACCP2:
.word TTAP,ATEXE
ACCP3:
.word BRAN,ACCP1
ACCP4:
.word DROP,OVER,SUBB,EXIT

EXPEC:  .word   dolst
.word TEXPE,ATEXE,SPAN,STORE,DROP,EXIT

QUERY:  .word   dolst
.word TIB,DOLIT,80,TEXPE,ATEXE,NTIB,STORE
.word DROP,DOLIT,0,INN,STORE,EXIT


 ##### error checking words #####


CATCH:  .word   dolst
.word SPAT,TOR,HANDL,AT,TOR
.word RPAT,HANDL,STORE,EXECU
.word RFROM,HANDL,STORE
.word RFROM,DROP,DOLIT,0,EXIT

THROW:  .word   dolst
.word HANDL,AT,RPSTO
.word RFROM,HANDL,STORE
.word RFROM,SWAP,TOR,SPSTO
.word DROP,RFROM,EXIT

NULLS:  .word   dolst
.word DOVAR
.word 0
.byte 99,111,121,111,116,101  
  # $align

ABORT:  .word   dolst
.word NULLS,THROW

ABORQ:  .word   dolst
.word QBRAN,ABOR1
.word DOSTR,THROW
ABOR1:
.word DOSTR,DROP,EXIT


   ###### text interpreter #####


INTER:  .word   dolst
.word NAMEQ,QDUP
.word QBRAN,INTE1
.word AT,DOLIT,0x40000000       #COMP
.word ANDD
.word ABORQ
.ascii "\X0d COMPILE ONLY"   
.word EXECU,EXIT
INTE1:
.word TNUMB,ATEXE
.word QBRAN,INTE2
.word EXIT
INTE2:
.word THROW

LBRAC:  .word   dolst
.word DOLIT,INTER,TEVAL,STORE,EXIT

DOTOK:  .word   dolst
.word DOLIT,INTER,TEVAL,AT,EQUAL
.word QBRAN,DOTO1
.word DOTQP
.ascii "\X03 ok" 
DOTO1:
.word CR,EXIT

QSTAC:  .word   dolst
.word DEPTH,ZLESS
.word ABORQ
.ascii "\X0a underflow"
.word EXIT

EVAL:   .word   dolst
EVAL1:
.word TOKEN,DUPP,CAT
.word QBRAN,EVAL2
.word TEVAL,ATEXE,QSTAC
.word BRAN,EVAL1   
EVAL2:
.word DROP,TPROM,ATEXE,EXIT

PRESE:  .word   dolst
.word SZERO,AT,SPSTO
.word DOLIT,TIBB,NTIB,CELLP,STORE,EXIT

XIO:    .word   dolst
.word DOLIT,ACCEP,TEXPE,DSTOR
.word TECHO,DSTOR,EXIT

FILE:   .word   dolst
.word DOLIT,PACE,DOLIT,DROP
.word DOLIT,KTAP,XIO,EXIT

HAND:   .word   dolst
.word DOLIT,DOTOK,DOLIT,EMIT
.word DOLIT,KTAP,XIO,EXIT

ISLO:   .word   dolst
.word DOVAR
.word QRX,TXSTO

CONSO:  .word   dolst
.word ISLO,DAT,TQKEY,DSTOR
.word HAND,EXIT

QUIT:   .word   dolst
.word RZERO,AT,RPSTO
QUIT1:
.word LBRAC
QUIT2:
.word QUERY
.word DOLIT,EVAL,CATCH,QDUP
.word QBRAN,QUIT2
.word TPROM,AT,SWAP
.word CONSO,NULLS,OVER,XORR
.word QBRAN,QUIT3
.word SPACE,COUNT,TYPEE
.word DOTQP
.ascii "\X02 ?"
QUIT3:
.word DOLIT,DOTOK,XORR
.word QBRAN,QUIT4
.word DOLIT,ERR,EMIT
QUIT4:
.word PRESE
.word BRAN,QUIT1

TICK:   .word   dolst
.word TOKEN,NAMEQ
.word QBRAN,TICK1
.word EXIT
TICK1:
.word THROW


 ##### compiler words #####


ALLOT:  .word   dolst
.word CP,PSTOR,EXIT

COMMA:  .word   dolst
.word HERE,DUPP,CELLP
.word CP,STORE,STORE,EXIT

BCOMP:  .word   dolst
.word TICK,COMMA,EXIT

COMPI:  .word   dolst
.word   RFROM, DUPP, AT, COMMA
.word   CELLP, TOR, EXIT

LITER:  .word   dolst
.word   COMPI, DOLIT, COMMA, EXIT

STRCQ:  .word   dolst
.word DOLIT,34,WORDD
.word COUNT,PLUS,ALGND
.word CP,STORE,EXIT

RECUR:  .word   dolst
.word LAST,AT,NAMET,COMMA,EXIT

FOR:    .word   dolst
.word COMPI,TOR,HERE,EXIT

BEGIN:  .word   dolst
.word HERE,EXIT

NEXT:   .word   dolst
.word COMPI,DONXT,COMMA,EXIT

UNTIL:  .word   dolst
.word COMPI,QBRAN,COMMA,EXIT

AGAIN:  .word   dolst
.word COMPI,BRAN,COMMA,EXIT

IFF:    .word   dolst
.word COMPI,QBRAN,HERE
.word DOLIT,0,COMMA,EXIT

AHEAD:  .word   dolst
.word COMPI,BRAN,HERE,DOLIT,0,COMMA,EXIT

REPEA:  .word   dolst
.word AGAIN, HERE, SWAP, STORE, EXIT

THENN:  .word   dolst
.word HERE,SWAP,STORE,EXIT

AFT:    .word   dolst
.word DROP,AHEAD,BEGIN,SWAP,EXIT

ELSEE:  .word   dolst
.word AHEAD,SWAP,THENN,EXIT

WHILE:  .word   dolst
.word IFF,SWAP,EXIT

ABRTQ:  .word   dolst
.word COMPI,ABORQ,STRCQ,EXIT

STRQ:   .word   dolst
.word COMPI,STRQP,STRCQ,EXIT

DOTQ:   .word   dolst
.word COMPI,DOTQP,STRCQ,EXIT

UNIQU:  .word   dolst
.word DUPP,NAMEQ
.word QBRAN,UNIQ1
.word DOTQP
.ascii "\X07 reDef "  # "D$"
.word OVER,COUNT,TYPEE
UNIQ1:
.word DROP,EXIT

SNAME:  .word   dolst
.word DUPP,CAT
.word QBRAN,PNAM1
.word UNIQU
.word DUPP,LAST,STORE
.word HERE,ALGND,SWAP
.word CELLM
.word CRRNT,AT,AT,OVER,STORE
.word CELLM,DUPP,NP,STORE
.word STORE,EXIT
PNAM1:
.word STRQP
.ascii "\X05 name"   # "D$"
.word THROW

SCOMP:  .word   dolst
.word NAMEQ,QDUP
.word QBRAN,SCOM2
.word AT,DOLIT,0x80000000,ANDD
.word QBRAN,SCOM1
.word EXECU,EXIT
SCOM1:
.word COMMA,EXIT
SCOM2:
.word TNUMB,ATEXE
.word QBRAN,SCOM3
.word LITER,EXIT
SCOM3:
.word THROW

OVERT:  .word   dolst
.word LAST,AT,CRRNT,AT,STORE,EXIT

SEMIS:  .word   dolst
.word COMPI,EXIT,LBRAC,OVERT,EXIT

RBRAC:  .word   dolst
.word DOLIT,SCOMP,TEVAL,STORE,EXIT

CALLC:  .word   dolst
.word DOLIT,CALLC,AT
.word COMMA
.word EXIT

COLON:  .word   dolst
.word TOKEN,SNAME,DOLIT,DOLST
.word CALLC,RBRAC,EXIT

IMMED:  .word   dolst
.word DOLIT,0x80000000,LAST,AT,AT,ORR
.word LAST,AT,STORE,EXIT

USER:   .word   dolst
.word TOKEN,SNAME,OVERT
.word DOLIT,DOLST,CALLC
.word COMPI,DOUSE,COMMA,EXIT

CREAT:  .word   dolst
.word TOKEN,SNAME,OVERT
.word DOLIT,DOLST,CALLC
.word COMPI,DOVAR,EXIT

VARIA:  .word   dolst
.word CREAT,DOLIT,0,COMMA,EXIT


 ##### utility words #####


UTYPE:  .word   dolst
.word TOR
.word BRAN,UTYP2
UTYP1:
.word DUPP,CAT,TCHAR,EMIT
.word DOLIT,1,PLUS
UTYP2:
.word DONXT,UTYP1
.word DROP,EXIT

DMP:    .word   dolst
.word OVER,DOLIT,4,UDOTR,SPACE,TOR
.word BRAN,PDUM2
PDUM1:
.word DUPP,CAT,DOLIT,3,UDOTR
.word DOLIT,1,PLUS
PDUM2:
.word DONXT,PDUM1
.word EXIT

DUMP:   .word   dolst
.word BASE,AT,TOR,HEX
.word DOLIT,16,SLASH
.word TOR
DUMP1:
.word CR,DOLIT,16,DDUP,DMP
.word ROT,ROT
.word SPACE,SPACE,UTYPE
 #      .word NUFQ
 #      .word INVER
 #      .word QBRAN,DUMP2
.word DONXT,DUMP1
 #      .word BRAN,DUMP3
 #      DUMP2:
 #      .word RFROM,DROP
DUMP3:
.word DROP,RFROM,BASE,STORE
.word EXIT

DOTS:   .word   dolst
.word CR,DEPTH
.word TOR
.word BRAN,DOTS2
DOTS1:
.word RAT,PICK,DOT
DOTS2:
.word DONXT,DOTS1
.word DOTQP
.ascii "\X04 <sp"  # D$
.word EXIT

STCSP:  .word   dolst
.word SPAT,CSP,STORE,EXIT

QCSP:   .word   dolst
.word SPAT,CSP,AT, XORR, ABORQ
.ascii  "\X07 stacks"
.word   EXIT

TNAME:  .word   dolst
.word CRRNT
TNAM1:
.word CELLP,AT,QDUP
.word QBRAN,TNAM4
.word DDUP
TNAM2:
.word AT,DUPP
.word QBRAN,TNAM3
.word DDUP,NAMET,XORR
.word QBRAN,TNAM3
.word CELLM
.word BRAN,TNAM2
TNAM3:
.word SWAP,DROP,QDUP
.word QBRAN,TNAM1
.word SWAP,DROP,SWAP,DROP,EXIT
TNAM4:
.word DROP,DOLIT,0,EXIT

DOTID:  .word   dolst
.word QDUP
.word QBRAN,DOTI1
.word COUNT,DOLIT,0x1F,ANDD
.word UTYPE,EXIT
DOTI1:
.word DOTQP
.ascii "\X09 {noName}"  # D$
.word EXIT

SEE:    .word   dolst
.word TICK
.word CR
SEE1:
.word CELLP,DUPP,AT
.word DOLIT,CALLC,AT,XORR
.word QBRAN,SEE5
.word DUPP,AT
.word TNAME
SEE2:
.word QDUP
.word QBRAN,SEE3
.word SPACE,DOTID
.word BRAN,SEE4
SEE3:
.word DUPP,AT,UDOT
SEE4:
 #      .word NUFQ
.word BRAN,SEE1
SEE5:
.word DROP,EXIT

WORDS:  .word   dolst
.word CR,CNTXT,AT
WORS1:
.word AT,QDUP
.word QBRAN,WORS2
.word DUPP,SPACE,DOTID
.word CELLM             
 #      .word NUFQ,QBRAN,WORS1
.word BRAN,WORS1
.word DROP
WORS2:
.word EXIT

 
 ##### include files #####


INCLU:  .word   dolst
.word INN,DAT,TOR,TOR
.word TIB,NTIB,AT,PLUS
.word BLANK,WORDD,DOLIT,1,PLUS
.word OPEN,QDUP
.word QBRAN,INCL1
.word NTIB,AT,INN,STORE
.word NTIB,PSTOR
.word EVAL
INCL1:
.word RFROM,RFROM,INN,DSTOR
.word EXIT


 ##### cold start #####


VERSN:  .word   dolst
.word DOLIT,0x103,EXIT

HI:     .word   dolst
.word STOIO,CR
.word DOTQP
.ascii "\X0emips eForth v"
.word BASE,AT,HEX
.word VERSN,BDIGS,DIG,DIG
.word DOLIT,46,HOLD
.word DIGS,EDIGS,TYPEE
.word BASE,STORE,CR,EXIT

TBOOT:  .word   dolst
.word DOVAR
.word HI

DIAG:   .word   dolst
.word DOLIT,101,TXSTO
.word DOLIT,0,ZLESS,DOLIT,-2,ZLESS,UPLUS,DROP
.word DOLIT,3,UPLUS,UPLUS,DROP,DOLIT,67,UPLUS,DROP,TXSTO
.word DOLIT,79,DOLIT,111,XORR,DOLIT,0xF0,ANDD
.word DOLIT,79,ORR,TXSTO
.word SPAT,SPAT,SWAP,OVER,XORR,DOLIT,CELLL,ANDD
.word DOLIT,114-CELLL,UPLUS,DROP
.word SWAP,DUPP,DUPP,SPSTO
.word TXSTO
.word DOLIT,0
QB1:
.word QBRAN,QB2,DOLIT,63,TXSTO
QB2:
.word DOLIT,-1,QBRAN,QB3,DOLIT,116,TXSTO,BRAN,QB4
QB3:
.word DOLIT,33,TXSTO
QB4:
.word DOLIT,0xff,SPAT
.word DOLIT,0xff,OVER,DOLIT,1,UPLUS,DROP,CSTOR
.word DOLIT,104,OVER,AT,ANDD,OVER,STORE
.word DUPP,AT,OVER,DOLIT,1,UPLUS,DROP,CAT,ORR
.word SWAP,STORE,TXSTO,DOLIT,32,TXSTO

.word DOLIT,77,TOR,RPAT
.word DOLIT,63,TOR,RPSTO,RFROM
.word TXSTO
.word SZERO,DOLIT,UPP+16,XORR
.word QBRAN,UCHK1,DOLIT,63,TXSTO
UCHK1:
.word DOLIT,117,TXSTO
.word DOLIT,0
.word DOLIT,0x1B,TOR
FOR1:
.word DOLIT,1,UPLUS,DROP,DONXT,FOR1
.word DOLIT,0x1C,XORR
.word QBRAN,NXTOK,DOLIT,63,TXSTO,EXIT
NXTOK:
.word DOLIT,108,TXSTO,EXIT

COLD:   .word   dolst
COLD1:
 #      .word   DIAG
 #      .word DOLIT,UZERO,DOLIT,UPP
 #      .word DOLIT,45,MOVEE
.word PRESE
.word TBOOT,ATEXE
.word FORTH,CNTXT,AT,DUPP
.word CRRNT,DSTOR,OVERT
.word QUIT
.word BRAN,COLD1  
        .word   dolst   # stop SEE here


CTOP:   .space 8000     # free code dictionary space upwords


NTOP:   .word   BYE, p0 # free name dictionary space downwards

LASTN:                  # name dictionary
        .byte   3
        .ascii  "BYE"
        .word   QRX, p1
p0:     .byte   3
        .ascii  "?RX"
        .word   TXSTO, p2
p1:     .byte   3
        .ascii  "TX!"
        .word   STOIO, p3
p2:     .byte   3
        .ascii  "!IO"
        .word   DOLIT, p4
p3:     .byte   5+COMPO
        .ascii  "doLIT"
        .word   DOLST, p5
p4:     .byte   6+COMPO
        .ascii  "doLIST"
        .word   EXIT, p6
p5:     .byte   4
        .ascii  "EXIT"
        .word   EXECU, p7
p6:     .byte   7
        .ascii  "EXECUTE"
        .word   DONXT, p8
p7:     .byte   4+COMPO
        .ascii  "next"    
        .word   QBRAN, p9
p8:     .byte   7+COMPO
        .ascii  "?branch"
        .word   BRAN, p10
p9:     .byte   6+COMPO
        .ascii  "branch"
        .word   STORE, p11
p10:    .byte   1,33
        .word   AT, p12
p11:    .byte   1
        .ascii  "@"
        .word   CSTOR, p13
p12:    .byte   2
        .ascii  "C!"
        .word   CAT, p14
p13:    .byte   2
        .ascii  "C@"
        .word   RPAT, p15
p14:    .byte   3
        .ascii  "RP@"
        .word   RPSTO, p16
p15:    .byte   3
        .ascii  "RP!"
        .word   RFROM, p17
p16:    .byte   2
        .ascii  "R>"
        .word   RAT, p18
p17:    .byte   2
        .ascii  "R@"
        .word   TOR, p19
p18:    .byte   2
        .ascii  ">R"
        .word   SPAT, p20
p19:    .byte   3
        .ascii  "SP@"
        .word   SPSTO, p21
p20:    .byte   3
        .ascii  "SP!"
        .word   DROP, p22
p21:    .byte   4
        .ascii  "DROP"
        .word   DUPP, p23
p22:    .byte   3
        .ascii  "DUP"
        .word   SWAP, p24
p23:    .byte   4
        .ascii  "SWAP"
        .word   OVER, p25
p24:    .byte   4
        .ascii  "OVER"
        .word   ZLESS, p26
p25:    .byte   2
        .ascii  "0<"
        .word   ANDD, p27
p26:    .byte   3
        .ascii  "AND"
        .word   ORR, p28
p27:    .byte   2
        .ascii  "OR"
        .word   XORR, p29
p28:    .byte   3
        .ascii  "XOR"
        .word   UPLUS, p30
p29:    .byte   3
        .ascii  "UM+"
        .word   DOVAR, p31
p30:    .byte   5+COMPO
        .ascii  "doVAR"
        .word   UP, p32
p31:    .byte   2
        .ascii  "UP"
        .word   DOUSE, p33
p32:    .byte   6+COMPO
        .ascii  "doUSER"
        .word   SZERO, p34
p33:    .byte   3
        .ascii  "SP0"
        .word   RZERO, p35
p34:    .byte   3
        .ascii  "RP0"
        .word   TQKEY, p36
p35:    .byte   5
        .ascii  "\'?KEY"
        .word   TEMIT, p37
p36:    .byte   5
        .ascii  "\'EMIT"
        .word   TEXPE, p38
p37:    .byte   7
        .ascii  "\'EXPECT"
        .word   TTAP, p39
p38:    .byte   4
        .ascii  "\'TAP"
        .word   TECHO, p40
p39:    .byte   5
        .ascii  "\'ECHO"
        .word   TPROM, p41
p40:    .byte   6
        .ascii  "PROMPT"
        .word   BASE, p42
p41:    .byte   4
        .ascii  "BASE"
        .word   TEMP, p43
p42:    .byte   3
        .ascii  "tmp"
        .word   SPAN, p44
p43:    .byte   4
        .ascii  "SPAN"
        .word   INN, p45
p44:    .byte   3
        .ascii  ">IN"
        .word   NTIB, p46
p45:    .byte   4
        .ascii  "\#TIB"
        .word   CSP, p47
p46:    .byte   3
        .ascii  "CSP"
        .word   TEVAL, p48
p47:    .byte   5
        .ascii  "\'EVAL"
        .word   TNUMB, p49
p48:    .byte   7
        .ascii  "\'NUMBER"
        .word   HLD, p50
p49:    .byte   3
        .ascii  "HLD"
        .word   HANDL, p51
p50:    .byte   7
        .ascii  "HANDLER"
        .word   CNTXT, p52
p51:    .byte   7
        .ascii  "CONTEXT"
        .word   CRRNT, p53
p52:    .byte   7
        .ascii  "CURRENT"
        .word   CP, p54
p53:    .byte   2
        .ascii  "CP"
        .word   NP, p55
p54:    .byte   2
        .ascii  "NP"
        .word   LAST, p56
p55:    .byte   4
        .ascii  "LAST"
        .word   DOVOC, p57
p56:    .byte   5+COMPO
        .ascii  "doVOC"
        .word   FORTH, p58
p57:    .byte   5
        .ascii  "FORTH"
        .word   QDUP, p59
p58:    .byte   4
        .ascii  "?DUP"
        .word   ROT, p60
p59:    .byte   3
        .ascii  "ROT"
        .word   DDROP, p61
p60:    .byte   5
        .ascii  "2DROP"
        .word   DDUP, p62
p61:    .byte   4
        .ascii  "2DUP"
        .word   PLUS, p63
p62:    .byte   1
        .ascii  "+"
        .word   DPLUS, p64
p63:    .byte   2
        .ascii  "D+"
        .word   INVER, p65
p64:    .byte   3
        .ascii  "NOT"
        .word   NEGAT, p66
p65:    .byte   6
        .ascii  "NEGATE"
        .word   DNEGA, p67
p66:    .byte   7
        .ascii  "DNEGATE"
        .word   SUBB, p68
p67:    .byte   1
        .ascii  "-"
        .word   ABSS, p69
p68:    .byte   3
        .ascii  "ABS"
        .word   EQUAL, p70
p69:    .byte   1
        .ascii  "="
        .word   ULESS, p71
p70:    .byte   2
        .ascii  "U<"
        .word   LESS, p72
p71:    .byte   1
        .ascii  "<"
        .word   MAX, p73
p72:    .byte   3
        .ascii  "MAX"
        .word   MIN, p74
p73:    .byte   3
        .ascii  "MIN"
        .word   WITHI, p75
p74:    .byte   6
        .ascii  "WITHIN"
        .word   UMMOD, p76
p75:    .byte   6
        .ascii  "UM/MOD"
        .word   MSMOD, p77
p76:    .byte   5
        .ascii  "M/MOD"
        .word   SLMOD, p78
p77:    .byte   4
        .ascii  "/MOD"
        .word   MODD, p79
p78:    .byte   3
        .ascii  "MOD"
        .word   SLASH, p80
p79:    .byte   1
        .ascii  "/"
        .word   UMSTA, p81
p80:    .byte   3
        .ascii  "UM*"
        .word   STAR, p82
p81:    .byte   1
        .ascii  "*"
        .word   MSTAR, p83
p82:    .byte   2
        .ascii  "M*"
        .word   SSMOD, p84
p83:    .byte   5
        .ascii  "*/MOD"
        .word   STASL, p85
p84:    .byte   2
        .ascii  "*/"
        .word   CELLP, p86
p85:    .byte   5
        .ascii  "CELL+"
        .word   CELLM, p87
p86:    .byte   5
        .ascii  "CELL-"
        .word   CELLS, p88
p87:    .byte   5
        .ascii  "CELLS"
        .word   ALGND, p89
p88:    .byte   7
        .ascii  "ALIGNED"
        .word   BLANK, p90
p89:    .byte   2
        .ascii  "BL"
        .word   TCHAR, p91
p90:    .byte   5
        .ascii  ">CHAR"
        .word   DEPTH, p92
p91:    .byte   5
        .ascii  "DEPTH"
        .word   PICK, p93
p92:    .byte   4
        .ascii  "PICK"
        .word   PSTOR, p94
p93:    .byte   2
        .ascii  "+!"
        .word   DSTOR, p95
p94:    .byte   2
        .ascii  "2!"
        .word   DAT, p96
p95:    .byte   2
        .ascii  "2@"
        .word   COUNT, p97
p96:    .byte   5
        .ascii  "COUNT"
        .word   HERE, p98
p97:    .byte   4
        .ascii  "HERE"
        .word   PAD, p99
p98:    .byte   3
        .ascii  "PAD"
        .word   TIB, p100
p99:    .byte   3
        .ascii  "TIB"
        .word   ATEXE, p101
p100:   .byte   8
        .ascii  "@EXECUTE"
        .word   CMOVE, p102
p101:   .byte   5
        .ascii  "CMOVE"
        .word   FILL, p103
p102:   .byte   4
        .ascii  "FILL"
        .word   DTRAI, p104
p103:   .byte   9
        .ascii  "-TRAILING"
        .word   PACKS, p105
p104:   .byte   5
        .ascii  "PACK$"
        .word   DIGIT, p106
p105:   .byte   5
        .ascii  "DIGIT"
        .word   EXTRC, p107
p106:   .byte   7
        .ascii  "EXTRACT"
        .word   BDIGS, p108
p107:   .byte   2
        .ascii  "<\#"
        .word   HOLD, p109
p108:   .byte   4
        .ascii  "HOLD"
        .word   DIG, p110
p109:   .byte   1
        .ascii  "\#"
        .word   DIGS, p111
p110:   .byte   2
        .ascii  "#S"
        .word   SIGN, p112
p111:   .byte   4
        .ascii  "SIGN"
        .word   EDIGS, p113
p112:   .byte   2
        .ascii  "\#>"
        .word   STRR, p114
p113:   .byte   3
        .ascii  "str"
        .word   HEX, p115
p114:   .byte   3
        .ascii  "HEX"
        .word   DECIM, p116
p115:   .byte   7
        .ascii  "DECIMAL"
        .word   DIGTQ, p117
p116:   .byte   6
        .ascii  "DIGIT?"
        .word   NUMBQ, p118
p117:   .byte   7
        .ascii  "NUMBER?"
        .word   QKEY, p119
p118:   .byte   4
        .ascii  "?KEY"
        .word   KEY, p120
p119:   .byte   3
        .ascii  "KEY"
        .word   EMIT, p121
p120:   .byte   4
        .ascii  "EMIT"
        .word   NUFQ, p122
p121:   .byte   4
        .ascii  "NUF?"
        .word   PACE, p123
p122:   .byte   4
        .ascii  "PACE"
        .word   SPACE, p124
p123:   .byte   5
        .ascii  "SPACE"
        .word   SPACS, p125
p124:   .byte   6
        .ascii  "SPACES"
        .word   TYPEE, p126
p125:   .byte   4
        .ascii  "TYPE"
        .word   CR, p127
p126:   .byte   2
        .ascii  "CR"
        .word   DOSTR, p128
p127:   .byte   3+COMPO
        .ascii  "do$"
        .word   STRQP, p128a
p128:   .byte   3+COMPO
        .ascii  "$\"|"
        .word   DOTQP, p129
p128a:  .byte   3+COMPO
        .ascii  ".\"|"
        .word   DOTR, p130
p129:   .byte   2
        .ascii  ".R"
        .word   UDOTR, p131
p130:   .byte   3
        .ascii  "U.R"
        .word   UDOT, p132
p131:   .byte   2
        .ascii  "U."
        .word   DOT, p133
p132:   .byte   1
        .ascii  "."
        .word   QUEST, p134
p133:   .byte   1
        .ascii  "?"
        .word   PARS, p135
p134:   .byte   5
        .ascii  "parse"
        .word   PARSE, p136
p135:   .byte   5
        .ascii  "PARSE"
        .word   DOTPR, p137
p136:   .byte   2+IMEDD
        .ascii  ".("
        .word   PAREN, p138
p137:   .byte   1+IMEDD
        .ascii  "("
        .word   BKSLA, p139
p138:   .byte   1+IMEDD
        .ascii  "\\"
        .word   CHAR, p140
p139:   .byte   4
        .ascii  "CHAR"
        .word   TOKEN, p141
p140:   .byte   5
        .ascii  "TOKEN"
        .word   WORDD, p142
p141:   .byte   4
        .ascii  "WORD"
        .word   NAMET, p143
p142:   .byte   5
        .ascii  "NAME>"
        .word   SAMEQ, p144
p143:   .byte   5
        .ascii  "SAME?"
        .word   FIND, p145
p144:   .byte   4
        .ascii  "find"
        .word   NAMEQ, p146
p145:   .byte   5
        .ascii  "NAME?"
        .word   BKSP, p147
p146:   .byte   2
        .ascii  "^H"
        .word   TAP, p148
p147:   .byte   3
        .ascii  "TAP"
        .word   KTAP, p149
p148:   .byte   4
        .ascii  "kTAP"
        .word   ACCEP, p150
p149:   .byte   6
        .ascii  "accept"
        .word   EXPEC, p151
p150:   .byte   6
        .ascii  "EXPECT"
        .word   QUERY, p152
p151:   .byte   5
        .ascii  "QUERY"
        .word   CATCH, p153
p152:   .byte   5
        .ascii  "CATCH"
        .word   THROW, p154
p153:   .byte   5
        .ascii  "THROW"
        .word   NULLS, p155
p154:   .byte   5
        .ascii  "NULL$"
        .word   ABORT, p156
p155:   .byte   5
        .ascii  "ABORT"
        .word   ABORQ, p157
p156:   .byte   6
        .ascii  "abort\""
        .word   INTER, p158
p157:   .byte   10
        .ascii  "$INTERPRET"
        .word   LBRAC, p159
p158:   .byte   1+IMEDD
        .ascii  "["
        .word   DOTOK, p160
p159:   .byte   3
        .ascii  ".OK"
        .word   QSTAC, p161
p160:   .byte   6
        .ascii  "?STACK"
        .word   EVAL, p162
p161:   .byte   4
        .ascii  "EVAL"
        .word   PRESE, p163
p162:   .byte   6
        .ascii  "PRESET"
        .word   XIO, p164
p163:   .byte   3+COMPO
        .ascii  "xio"
        .word   FILE, p164a
p164:   .byte   4
        .ascii  "FILE"
        .word   OPEN, p165
p164a:  .byte   4
        .ascii  "OPEN"
        .word   HAND, p166
p165:   .byte   4
        .ascii  "HAND"
        .word   ISLO, p167
p166:   .byte   3
        .ascii  "I/O"
        .word   CONSO, p168
p167:   .byte   7
        .ascii  "CONSOLE"
        .word   QUIT, p169
p168:   .byte   4
        .ascii  "QUIT"
        .word   TICK, p170
p169:   .byte   1
        .ascii  "\'"
        .word   ALLOT, p171
p170:   .byte   5
        .ascii  "ALLOT"
        .word   COMMA, p172
p171:   .byte   1
        .ascii  ","
        .word   BCOMP, p173
p172:   .byte   9+IMEDD+COMPO
        .ascii  "[COMPILE]"
        .word   COMPI, p174
p173:   .byte   7+COMPO+COMPO
        .ascii  "COMPILE"
        .word   LITER, p175
p174:   .byte   7+IMEDD+COMPO
        .ascii  "LITERAL"
        .word   STRCQ, p176
p175:   .byte   3+COMPO
        .ascii  "$,\""
        .word   RECUR, p177
p176:   .byte   7+IMEDD+COMPO
        .ascii  "RECURSE"
        .word   FOR, p178
p177:   .byte   3+IMEDD+COMPO
        .ascii  "FOR"
        .word   BEGIN, p179
p178:   .byte   5+IMEDD+COMPO
        .ascii  "BEGIN"
        .word   NEXT, p180
p179:   .byte   4+IMEDD+COMPO
        .ascii  "NEXT"
        .word   UNTIL, p181
p180:   .byte   5+IMEDD+COMPO
        .ascii  "UNTIL"
        .word   AGAIN, p182
p181:   .byte   5+IMEDD+COMPO
        .ascii  "AGAIN"
        .word   IFF, p183
p182:   .byte   2+IMEDD+COMPO
        .ascii  "IF"
        .word   AHEAD, p184
p183:   .byte   5+IMEDD+COMPO
        .ascii  "AHEAD"
        .word   REPEA, p185
p184:   .byte   6+IMEDD+COMPO
        .ascii  "REPEAT"
        .word   THENN, p186
p185:   .byte   4+IMEDD+COMPO
        .ascii  "THEN"
        .word   AFT, p187
p186:   .byte   3+IMEDD+COMPO
        .ascii  "AFT"
        .word   ELSEE, p188
p187:   .byte   4+IMEDD+COMPO
        .ascii  "ELSE"
        .word   WHILE, p189
p188:   .byte   5+IMEDD+COMPO
        .ascii  "WHILE"
        .word   ABRTQ, p190
p189:   .byte   6+IMEDD+COMPO
        .ascii  "ABORT\""
        .word   STRQ, p191
p190:   .byte   2+IMEDD+COMPO
        .ascii  "$\""
        .word   DOTQ, p192
p191:   .byte   2+IMEDD+COMPO
        .ascii  ".\""
        .word   UNIQU, p193
p192:   .byte   7
        .ascii  "?UNIQUE"
        .word   SNAME, p194
p193:   .byte   3
        .ascii  "$\,n"
        .word   SCOMP, p195
p194:   .byte   8
        .ascii  "$COMPILE"
        .word   OVERT, p196
p195:   .byte   5
        .ascii  "OVERT"
        .word   SEMIS, p197
p196:   .byte   1+IMEDD+COMPO
        .ascii  ";"
        .word   RBRAC, p198
p197:   .byte   1
        .ascii  "]"
        .word   CALLC, p199
p198:   .byte   5
        .ascii  "call\,"
        .word   COLON, p200
p199:   .byte   1
        .ascii  ":"
        .word   IMMED, p201
p200:   .byte   9
        .ascii  "IMMEDIATE"
        .word   USER, p202
p201:   .byte   5
        .ascii  "USER"
        .word   CREAT, p203
p202:   .byte   6
        .ascii  "CREATE"
        .word   VARIA, p204
p203:   .byte   8
        .ascii  "VARIABLE"
        .word   UTYPE, p205
p204:   .byte   5
        .ascii  "_TYPE"
        .word   DMP, p206
p205:   .byte   3
        .ascii  "dm+"
        .word   DUMP, p207
p206:   .byte   4
        .ascii  "DUMP"
        .word   DOTS, p208
p207:   .byte   2
        .ascii  ".S"
        .word   STCSP, p209
p208:   .byte   4
        .ascii  "!CSP"
        .word   QCSP, p210
p209:   .byte   4
        .ascii  "?CSP"
        .word   TNAME, p211
p210:   .byte   5
        .ascii  ">NAME"
        .word   DOTID, p212
p211:   .byte   3
        .ascii  ".ID"
        .word   SEE, p213
p212:   .byte   3
        .ascii  "SEE"
        .word   WORDS, p214a
p213:   .byte   5
        .ascii  "WORDS"
        .word   INCLU, p214
p214a:  .byte   7
        .ascii  "INCLUDE"
        .word   VERSN, p215
p214:   .byte   3
        .ascii  "VER"
        .word   HI, p216
p215:   .byte   2
        .ascii  "hi"
        .word   TBOOT, p217
p216:   .byte   5
        .ascii  "\'BOOT"
        .word   DIAG, p218
p217:   .byte   8
        .ascii  "DIAGNOSE"
        .word   COLD, 0
p218:   .byte   4
        .ascii  "COLD"
        .word   0
p219:   .word   0,0,0,0

DATA0:  .space  512
SPP:    .word   0               # data stack
INBUF:  .space  512             # buffer for 'read'
RPP:    .word   0               # return stack
UZERO:
UPP:    .space  16              # user area
        .word   SPP
        .word   RPP
        .word   QRX
        .word   TXSTO
        .word   ACCEP
        .word   KTAP
        .word   DROP            # TXSTO
        .word   DOTOK
        .word   BASEE
        .word   0, 0, 
TINN:   .word   0
NTIBB:  .word   0
        .word   TIBB
        .word   0
        .word   INTER
        .word   NUMBQ
        .word   0, 0, 0
        .space  32
        .word   0, 0
        .word   CTOP
        .word   NTOP
        .word   LASTN
ULAST:  .word   0, 0, 0, 0
        .word   0, 0, 0, 0
FVOC:   .word   LASTN
        .word   0, 0, 0, 0      # editor, assembly, application
SAVLINK:.word   0
SAVSP:  .word   0
        
msg1:   .asciiz "%s\n"
msg2:   .asciiz "%80c"
msg3:   .asciiz "ok>"
msg4:   .asciiz "hi.f\000"
msg5:   .asciiz "file read error\X0A\X00"
msg6:   .asciiz "step 6\n"
msg7:   .asciiz "step 7\n"
msg8:   .asciiz "rp=%x r0=%x r1=%x\X0A\X00"
msg9:   .asciiz "sp=%x ip=%x wp=%x\X0A\X00"
msg10:  .asciiz "s0=%x s1=%x s2=%x\X0A\X00"

TIBB:
FBUFF:  .space 100000           # terminal input buffer and file buffer

        .end    eForth

<109 weaver2 /work/ls> 